// pvectors.h:   
// (c) Khashin S.I.  khash2@gmail.com
//
#ifdef PVECTORS
#error Secondary include
#endif
#define PVECTORS


////////////////////////////////////////////////////////////////////////////////
class pnt {
public:
	int x, y;
	pnt(int x_ = 0, int y_ = 0) { x = x_; y = y_; };
	bool operator==(pnt& rhs) { return x == rhs.x && y == rhs.y; };
};

////////////////////////////////////////////////////////////////////////////////
class pvector{	//  
	vector<pnt> v;
public:
	pvector(int n=0);
	void	setSize(int n);
	void	clear() { v.clear(); }	
	int     size() { return (int)v.size(); }
	pnt     &operator[] (int i) { return v[i]; }
	pnt     &get        (int i) { return v[i]; }
	int		getX(int i) { return v[i].x; }	// x- i- 
	int		getY(int i) { return v[i].y; }	// y- i- 
	void	add(pnt  &p) { v.push_back(p); }//    
	void	add(int x, int y) { v.push_back(pnt(x,y)); }//    
	void	add(pvector &w);
	void	add9(int x, int y);		//  9  (3*3)  
	int		maxX();					//   x-
	int		maxY();					//   y-
	int		minX();					//   x-
	int		minY();					//   y-
	void	del(int k0, int k1) { v.erase(v.begin() + k0, v.begin() + k1 + 1); };	// delete points [k0..k1] exactly
	int		indexOf(pnt p);			//   p  , -1 -  

	// 
	void	sortByX();				//        X
	void	sortByX_();				//     X
	void	sortByY();				//        Y
	void	sortByY_();				//     Y

	void    createCircle(int x0, int y0, double rad, int mx = 0, int my = 0);	//  .  mx,my>0,        
	void    createBox(int x0, int y0, int dx, int dy);							//  
	//     ,   ,      k:
	void    createCircleK(int x0, int y0, double rad, int K, int mx = 0, int my = 0);	//  .  mx,my>0,        
	void    createBoxK(int x0, int y0, int dx, int dy, int K);							//  

	void	save(char *filename, char *msg, int k = 1, char *frm = " (%4d,%4d)");	//     k      frm
	void	load(char *filename);	//   
	void	convexHull(pvector &p);// this =  (p)

	double midPoint(pnt &m);		// m -    p[i],     
	double midPoint(double &x1, double &y1);	// (x1,y1)    p[i],     

	//  
	void reduceList(pvector &list, int newSize);	// this:=    list ,   ~newSize
	void listDivide(pvector &list, int k, int mx = 0, int my = 0);	// dst:=src div k

/*
	void	setUniq( int u ){ uniq=u; };//   .
	pnt		*getPoint(int i);		//   i-   
	int		indexOf( pnt p );		//   p  , -1 -  
	void	DeleteDupes();			//     
	void	DeleteAlmostDupes(int r);//    (distance<=r)  




	//    
	void   middPoint (pnt &m);		// m -   
	int    mostFarPoint(pnt &a);	//    p    a 
	int    nearestPoint(pnt &a);	//    p     a 

	void listDivide( pvector &list, int k, int mx=0, int my=0);	// dst:=src div k
	void listDividQ( pvector &list, int k, int mx=0, int my=0);	//   listDivide
*/
};

//   ,    
//void   swapPoints(pnt &p1, pnt &p2);		//  
//double angle(double x, double y);			//  (0..2Pi)  (x,y)   X.
//double angle(pnt &a, pnt &b, pnt &c);		//  <abc>  0  2*Pi
//double kAngle(pnt &a0, pnt &a1);			//   
//double Pdistance(pnt &a0, pnt &a1);		//   
