// segment3.cpp: -   
// 2015-11-20
//
//#pragma warning(disable : 4996)
#pragma warning(disable: 4800) // 'int' : forcing value to bool 'true' or 'false'...

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <memory.h>
#include <limits.h>
#include <vector>
using namespace std;

#include "vUtil.h"			//   
#include "iMatrix.h"		//  
#include "iMatrix3.h"		//  3-
#include "pvectors.h"		//      
#include "histogram.h"		// 
#include "segment.h"		//   

/////////////////////////////////////////////////////////////////////////////
// 2017-02-04   vUtil
//              3
//            2 * 0
//              1
//void neighbor(int x, int y, int k, int &x1, int &y1); //    k=0|1|2|3
//			  7 3 4
//			  2 * 0
//			  6 1 5
//void neighbor8(int x, int y, int k, int &x1, int &y1);	//    k=0..7

/////////////////////////////////////////////////////////////////////////////
//       9 
//       4 
//     -   6 
void listVicinity( pvector &list, int x0, int y0, int mx, int my) // list -     (x0,y0);
{
	int xMin = (x0==0    ? 0  : x0-1);
	int xMax = (x0==mx-1 ? x0 : x0+1);
	int yMin = (y0==0    ? 0  : y0-1);
	int yMax = (y0==my-1 ? y0 : y0+1);
	list.clear();

	for( int y=yMin; y<=yMax; y++ )
	for( int x=xMin; x<=xMax; x++ )
	list.add(x,y);
}

//////////////////////////////////////////////////////////////////
/////////////////////////// class segm /////////////////////////
//////////////////////////////////////////////////////////////////
segm::segm(int mx_, int my_ ): matr(mx_, my_) 
{
	max=-1;
	aSz =-1;
	area=NULL;							//  
	midX=NULL; midY=NULL; offs=NULL;	//    ..  
	midR=NULL; midG=NULL; midB=NULL;;	//    
}
//////////////////////////////////////////////////////////////////
segm::~segm() 
{
	this->sRelease();
}
//-----------------------------------------------------------------------------
void	segm::sRelease()			//  .
{
	if (aSz>0)
	{
		delete[]area;		//  
		delete[]midX;
		delete[]midY;
		delete[]offs;
		delete[]midR;
		delete[]midG;
		delete[]midB;
		aSz = -1;
	}
	top.release();
	ctop.release();
	//brd.release();
	max = -1;
}//void	segm::sRelease()			//  .

//////////////////////////////////////////////////////////////////
int segm::Max()//   
{
	if(max<0) max = maximal();
	return max;
}

/////////////////////////////////////////////////////////////////////////////
//   ,   drawSegments(char *bmpname) 
static void rSegmentColor(int iSegm, int &r, int &g, int &b)
{
	if (iSegm == 0) { r = g = b = 0; return; }
	if (iSegm<0) iSegm = -iSegm;
	{
		r = (73 + iSegm * 100) % 239 + 10;
		g = (173 + iSegm * 133) % 241 + 5;
		b = (33 + iSegm * 72) % 251 + 3;
	}
}
void segm::drawSegments(char *bmpname)	//     bmpname  
{
	matr rgb(mx, my);	//      
	int cr, cg, cb;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			rSegmentColor(get(x, y), cr, cg, cb);
			//!!   :
			cr = get(x, y) % 256;
			rgb.put(x, y, rgb_int(cr, cg, cb));
		}
	rgb.saveBMP(bmpname);
}
//////////////////////////////////////////////////////////////////
void segm::drawSegments(matr3 &a, char *bmpname)	//      rgb   bmpname
{
	matr3 a3;	 a3.copyFrom(a); //      
								 //    ,      4-  ,   
	int s;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			s = get(x, y);
			if (safeGet(x - 1, y) > s ||
				safeGet(x + 1, y) > s ||
				safeGet(x, y - 1) > s ||
				safeGet(x, y + 1) > s)
			{
				//     . 
				//      :
				//      128
				s = a3.r.get(x, y); s = (s + 128) % 256; a3.r.put(x, y, s);
				s = a3.g.get(x, y); s = (s + 128) % 256; a3.g.put(x, y, s);
				s = a3.b.get(x, y); s = (s + 128) % 256; a3.b.put(x, y, s);
			}
		}
	a3.saveBMP(bmpname);
} // void segm::drawSegments( matr &rgb, char *bmpname )	//      rgb   bmpname
//////////////////////////////////////////////////////////////////
void segm::drawSegments(matr &rgb, char *bmpname)	//      rgb   bmpname
{
	matr a;	 a.copyFrom(rgb); //      
							  //    ,      4-  ,   
	int s;
	char *p;	//     
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			s = get(x, y);
			if (safeGet(x - 1, y) > s ||
				safeGet(x + 1, y) > s ||
				safeGet(x, y - 1) > s ||
				safeGet(x, y + 1) > s)
			{
				//     . 
				//      :
				//      128
				p = (char*)a.getElement(x, y);
				*p += 128; p++;	// R
				*p += 128; p++;	// G
				*p += 128; 	// B
			}
		}
	a.saveBMP(bmpname);
} // void segm::drawSegments( matr &rgb, char *bmpname )	//      rgb   bmpname
//////////////////////////////////////////////////////////////////
void segm::drawSegments(matr &r, matr &g, matr &b, char *bmpname)	//      rgb   bmpname
{
	matr a;
	a.fromRGB(r, g, b); //      
	this->drawSegments(a, bmpname);
}


//////////////////////////////////////////////////////////////////
int segm::minInSegm(int k, matr &a, int &x, int &y) // .  a   #k
{
	test(); testSameSize(a);
	int x0, y0, v0, vmin;
	vmin = 999999999; x = y = -1;
	for (y0 = 0; y0<my; y0++)
		for (x0 = 0; x0<mx; x0++)
		{
			if (get(x0, y0) != k) continue;
			v0 = a.get(x0, y0);
			if (v0<vmin) { vmin = v0; x = x0; y = y0; }
		}
	return vmin;
}
//////////////////////////////////////////////////////////////////
int segm::maxInSegm(int k, matr &a, int &x, int &y) // .  a   #k
{
	test(); testSameSize(a);
	int x0, y0, v0, vmax;
	vmax = -999999999; x = y = -1;
	for (y0 = 0; y0<my; y0++)
		for (x0 = 0; x0<mx; x0++)
		{
			if (get(x0, y0) != k) continue;
			v0 = a.get(x0, y0);
			if (v0>vmax) { vmax = v0; x = x0; y = y0; }
		}
	return vmax;
}
//////////////////////////////////////////////////////////////////
int segm::sumInSegm(int k, matr &a)//    a   #k
{
	test(); testSameSize(a);
	int x0, y0, vsum = 0;
	for (y0 = 0; y0<my; y0++)
		for (x0 = 0; x0<mx; x0++)
		{
			if (get(x0, y0) != k) continue;
			vsum += a.get(x0, y0);
		}
	return vsum;
}
//////////////////////////////////////////////////////////////////
double segm::midInSegm(int k, matr &a)//    a   #k
{
	test(); testSameSize(a);
	int x0, y0, cnt = 0;
	double vsum = 0;
	for (y0 = 0; y0<my; y0++)
		for (x0 = 0; x0<mx; x0++)
		{
			if (get(x0, y0) != k) continue;
			vsum += a.get(x0, y0);
			cnt++;
		}
	return vsum/cnt;
}
//////////////////////////////////////////////////////////////////
void segm::setInSegm(int k, matr &a, int v)		//   #k     a  v
{
	test(); testSameSize(a);
	int x0, y0;
	for (y0 = 0; y0<my; y0++)
		for (x0 = 0; x0<mx; x0++)
		{
			if (get(x0, y0) != k) continue;
			a.put(x0, y0, v);
		}
}

//////////////////////////////////////////////////////////////////
void segm::minimizeIndexes()	//    
{
	max = Max();
	int *ss = new int[max + 1];				//     0..maxS-1
	memset(ss, 0, (max + 1) * sizeof(int));

	int mx = Mx(), my = My();
	int x, y;
	for (y = 0; y<my; y++)
		for (x = 0; x<mx; x++)
		{
			int s = get(x, y);
			if (s>0) ss[s] = -1;
		}
	//   ss   ,  ,  -1
	//   
	int is, newind = 1;
	for (is = 1; is <= max; is++) {
		if (ss[is] == -1) ss[is] = newind++;
	}

	//   
	for (y = 0; y<my; y++)
		for (x = 0; x<mx; x++)
		{
			int s = get(x, y);
			if (s>0) put(x, y, ss[s]);
		}
	delete[]ss;
	max = this->maximal();
}//void segm::minimizeIndexes()	//    
 //////////////////////////////////////////////////////////////////
 // ,    >=0
 //   -  
 //  -    
void segm::sortBySize()	//    
{
	max = Max();
	if (max <= 0) vError("segm::sortBySize(): max<=0");

	//vShow("nSegm=%d\n", nSegm);
	int *area = new int[max + 1];
	this->areas(0, max, area);			//    0..max
	area[0] = 0; // ,   area[0]=0 !!!

	//  ,   ?
	bool isSort = true;
	int i;
	for (i = 1; i < max; i++)
		if (area[i]<area[i + 1]) { isSort = false; break; }
	if (isSort) {									//   
		delete[] area;
		return;
	}

	this->mult(-1);
	//      -   
	int im;
	for (i = 1; i <= max; i++) {
		imax(max + 1, area, im);				// im :=     
		if (im<0 || im>max) break;
		if (area[im] == 0) break;				//      
		area[im] = 0;							//     
		this->changeVal(-im, i);
	};

	max = this->maximal();
	if (max <= 0) vError("segm::sortBySize(): At the end: this->minimal()<0");
	delete[] area;
} // void segm::sortBySize()	//    

//////////////////////////////////////////////////////////////////
// ,    >=0
//   -  
//  -    
void segm::sortBySize(int i1, int i2) //  i1..i2     
{
	if (i1<0) vError("segm::sortBySize(%d,%d)", i1, i2);
	//if( this->minimal()<0 ) vError("segm::sortBySize(i1,i2): this->minimal()<0");
	if (i1 >= i2) return;							//  
	max = this->maximal();
	//int nSegm = this->maximal()+1;
	if (i2>max) i2 = max;
	if (i1 >= i2) return;							//  
	//  i1<i2
	//vShow("nSegm=%d\n", nSegm);
	int NN = i2 - i1 + 1;
	int *area = new int[NN];						//    
	this->areas(i1, i2, area);

	int i, x, y;
	//  ,   ?
	bool isSort = true;
	for (i = 0; i<NN - 1; i++)
		if (area[i]<area[i + 1]) { isSort = false; break; }
	if (isSort) {									//   
		delete[] area;
		return;
	}
	// area[i] -   i+i1

	// ,   area[0]=0 !!!  ----  sortBySize(i1,i2) -   
	//this->mult(-1);
	//   -1   
	for (y = 0; y<my; y++)
		for (x = 0; x<mx; x++)
		{
			i = this->get(x, y);
			if (i1 <= i && i <= i2) this->put(x, y, -i);
		}
	//      -   
	// area[i] -   -i-i1

	int im;
	for (i = 0; i<NN; i++) {
		//im = maxElementInIntVector(area, NN);		//     
		imax(NN, area, im);							// im :=     
		if (area[im] == 0) break;					//      
		area[im] = 0;								//     
		this->changeVal(-im - i1, i + i1);
	};
	delete[] area;
	max = this->maximal();
}// void segm::sortBySize(int i1, int i2) //  i1..i2     
//////////////////////////////////////////////////////////////////
void segm::join(int i, int j)	//   i  j   
{
	max = Max();
	if (i<0 || j<0) vError("segm::join, i=%d, j=%d, nSegm=%d", i, j, max);
	if (i>max || j>max) return;
	if (i == j) return;
	if (i>j) { int tmp = i; i = j; j = tmp; }
	//  0 <= i < j <= nSegm
	int x, y, s;
	for (y = 0; y<this->My(); y++)
		for (x = 0; x<this->Mx(); x++)
		{
			s = this->get(x, y);
			if (s == j)
				put(x, y, i);		//   j-   i-
			else if (s>j)
				put(x, y, s - 1);	//   ,  j    1
		}
	max = this->maximal();
} // void segm::join( int i, int j)	//   i  j   


//////////////////////////////////////////////////////////////////
void	segm::getList( pvector &list, int v )// list :=  ,   a[x,y]==v
{
	list.clear();
	addList(list, v);
}
//////////////////////////////////////////////////////////////////
void	segm::addList( pvector &list, int v )// list +=  ,   a[x,y]==v
{
	for( int y=0; y<my; y++ )
	for( int x=0; x<mx; x++ )
	if( get(x,y)==v ) list.add(x,y);
}
//////////////////////////////////////////////////////////////////
void	segm::setByList(pvector &list, int v )	//      v
{
	for( int i=0; i<list.size(); i++ )
		this->safePut( list.getX(i), list.getY(i), v  );
}
//////////////////////////////////////////////////////////////////
void	segm::areas( int v0, int v1, int *sz )	// sz[i] :=   v0+i
{
	int N, i, x, y, v;
	N = v1-v0+1;
	for( i=0; i<N; i++ ) sz[i]=0;

	for( y=0; y<my; y++ )
	for( x=0; x<mx; x++ )
	{
		v = get(x,y);
		if( v0<=v && v<=v1 ) sz[v-v0]++;
	}
}

//////////////////////////////////////////////////////////////////
//        v
//  v=-1,   v =    (x,y)
int segm::neighborCount (int x, int y, int v )//        v
{
	int count=0, x1,y1;
	if( v==-1 ) v = get(x,y);
	for( int k=0; k<8; k++ ) //   8-  
	{
		neighbor8(x,y, k, x1,y1);	// (x1,y1) -    (x,y)  k
		if( x1<0 || x1>=mx || y1<0 || y1>=my ) continue;//   
		if( get(x1,y1) != v ) count++;
	}
	return count;
}
//////////////////////////////////////////////////////////////////
//          v
//  v=-1,   v =    (x,y)
int segm::neighborCount2(int x, int y, int v )//          v
{
	int count=0, x1,y1;
	if( v==-1 ) v = get(x,y);
	for( int k=0; k<8; k++ ) //   8-  
	{
		neighbor8(x,y, k, x1,y1);	// (x1,y1) -    (x,y)  k
		if( x1<0 || x1>=mx || y1<0 || y1>=my ) continue;//   
		if( get(x1,y1) == v ) count++;
	}
	return count;
}
//////////////////////////////////////////////////////////////////
bool	segm::isBorder4( int x, int y ) //        4- 
{
	int x1, y1, k, v0;
	v0 = get(x,y);
	for( k=0; k<4; k++ )
	{
		neighbor( x,y, k, x1,y1);
		if( x1<0 || x1>=mx || y1<0 || y1>=my ) continue;
		if( get(x1,y1) != v0 ) return true;
	}
	return false;
}
bool	segm::isBorder8( int x, int y ) //        8- 
{
	int x1, y1, k, v0;
	v0 = get(x,y);
	for( k=0; k<8; k++ )
	{
		neighbor8( x,y, k, x1,y1);
		if( x1<0 || x1>=mx || y1<0 || y1>=my ) continue;
		if( get(x1,y1) != v0 ) return true;
	}
	return false;
}
//////////////////////////////////////////////////////////////////
//   
int segm::box( int iSegm, int &x0, int &y0, int &x1, int &y1) // (x0,y0)-(x1,y1) - ,  
{
	x0 = mx; x1 = -1;
	y0 = my; y1 = -1;
	int cnt=0;
	for( int y=0; y<my; y++ )
	for( int x=0; x<mx; x++ )
	if( get(x,y)==iSegm ) 
	{
		if( x<x0 ) x0=x;
		if( x>x1 ) x1=x;
		if( y<y0 ) y0=y;
		if( y>y1 ) y1=y;
		cnt ++;
	}
	return cnt;
}
//////////////////////////////////////////////////////////////////
bool	segm::isInBorder4( int x, int y, int iSegm )	//     iSegm,     4-  -  
{
	if( get(x,y) != iSegm ) return false;
	return isBorder4(x,y);
}
bool	segm::isInBorder8( int x, int y, int iSegm )	//     iSegm,     8-  -  
{
	if( get(x,y) != iSegm ) return false;
	return isBorder4(x,y);
}
//////////////////////////////////////////////////////////////////
bool	segm::isOutBorder4( int x, int y, int iSegm ) //      iSegm,     4-  - 
{
	if( get(x,y) == iSegm ) return false;
	//      != iSegm
	int x1, y1, k;
	for( k=0; k<4; k++ )
	{
		neighbor( x,y, k, x1,y1);
		if( x1<0 || x1>=mx || y1<0 || y1>=my ) continue;
		if( get(x1,y1) == iSegm ) return true;
	}
	return false;
}
bool	segm::isOutBorder8( int x, int y, int iSegm )//      iSegm,     8-  - 
{
	if( get(x,y) == iSegm ) return false;
	//      != iSegm
	int x1, y1, k;
	for( k=0; k<8; k++ )
	{
		neighbor8( x,y, k, x1,y1);
		if( x1<0 || x1>=mx || y1<0 || y1>=my ) continue;
		if( get(x1,y1) == iSegm ) return true;
	}
	return false;
}

//////////////////////////////////////////////////////////////////
void	segm::inBorder ( int iSegm, pvector &list )	// list :=      iSegm.   
{
	list.clear();
	for( int y=0; y<my; y++ )
	for( int x=0; x<mx; x++ )
		if( isInBorder8( x,y, iSegm) ) 
			list.add(x,y);
}

//////////////////////////////////////////////////////////////////
void	segm::outBorder( int iSegm, pvector &list )	// list :=      iSegm.   
{
	list.clear();
	for( int y=0; y<my; y++ )
	for( int x=0; x<mx; x++ )
		if( isOutBorder8( x,y, iSegm) ) 
			list.add(x,y);
}


//////////////////////////////////////////////////////////////////
//  list != NULL,      
// type = 4 : 4 
// type = 8 : 8  (*  )
//     (x0,y0)  v2.  
int	segm::connectRegion( int x0, int y0, int v2, int type, pvector *list)//     (x0,y0)  v2.  
{
	test();
	if( type != 4 && type != 8 ) vError("segm::connectRegion: illegal type =%d", type);
	int iSegm = get(x0,y0);			//  
	put(x0,y0,v2);					//   -     
	pvector act;					//   () 
	act.add(x0,y0);
	if( list )
	{
		list->clear();
		list->add(x0,y0);
	}
	int x,y, x1,y1;
	int count=1;					//   
	int iSeg1;						//   
	while( act.size()>0 )
	{
		x=act.getX(0);
		y=act.getY(0);
		act.del(0,0);			//     (x,y)      
		for( int k=0; k<type; k++ )		//   4-  8   
		{
			if( type==4) neighbor (x,y, k, x1,y1);	// (x1,y1) -    (x,y)  k
			else         neighbor8(x,y, k, x1,y1);	// (x1,y1) -    (x,y)  k
			if( x1<0 || x1>=mx || y1<0 || y1>=my ) continue;//   
			iSeg1 = get(x1,y1);			//   
			if( iSeg1==iSegm )	 		//     - 
			{
				put(x1,y1, v2 );
				act.add(x1,y1);
				if(list) list->add(x1,y1);
				count ++;
			} else	//   - 
			{
				//    !
				//if(iSeg1 != v2 && neib) neib->Add( iSeg1 );
			}
		}
	} // while( act.getSize()>0 )
	max = -1;							//    !
	return count;
} // int	segm::connectRegion( int x0, int y0, int v2 )//     (x0,y0)  v2.  
//////////////////////////////////////////////////////////////////
#define NOT_SEGM 0x80000000			//  -  " "
//  iSegm<0,     
bool segm::isConnected(int iSegm, int type)		//  ? iSegm<0 -   
{
	int nSegm, i, sSegm, rSegm;
	if( iSegm<0 )		//        
	{
		nSegm = this->maximal()+1;
		for( i=1; i<nSegm; i++ )
		{
			if( !this->isConnected( i, type) ) return false;
		}
		return true;
	}
	//    >0
	pvector list;
	this->getList(list, iSegm);
	sSegm = list.size();		//  
	rSegm = this->connectRegion(list.getX(0), list.getY(0), NOT_SEGM, type);
	this->changeVal(NOT_SEGM, iSegm);
	return sSegm==rSegm;
}
//////////////////////////////////////////////////////////////////
void segm::connectSegmentation(int type)	//        
{
	max = maximal();
	int max0 = Max();				//     0  max
	int mSeg = max0+1;				//    
	int s;
	for( int y=0; y<my; y++ )
	for( int x=0; x<mx; x++ )
	{
		s = get(x,y);
		if( s<0     ) continue;		//      
		if( s>max0  ) continue;		//    
		connectRegion(x,y, mSeg, type );
		mSeg++;
	}
	minimizeIndexes();
} // int	segm::connectSegmentation(int type=8)		//        
//////////////////////////////////////////////////////////////////
void segm::connectSegmentationP(int type)	//         (  )
{
	max = maximal();
	int max0 = Max();				//     0  max
	int mSeg = max+1;				//    
	int s;
	for( int y=0; y<my; y++ )
	for( int x=0; x<mx; x++ )
	{
		s = get(x,y);
		if( s<=0  ) continue;		//      
		if( s>max0 ) continue;		//    
		connectRegion(x,y, mSeg, type );
		mSeg++;
	}
	minimizeIndexes();
} // void segm::connectSegmentationP(int type)	//         (  )
//////////////////////////////////////////////////////////////////
int	segm::expandSegment( int iSegm )	//   iSegm     1 
{
	int size = changeVal(iSegm, -1);
	if( size==0 ) return 0;

	for( int y=0; y<my; y++ )
	for( int x=0; x<mx; x++ )
	{
		if( isOutBorder4( x,y, -1) ) put(x,y, iSegm);
	}
	return changeVal( -1, iSegm );
	max = -1;							//    !
}

//////////////////////////////////////////////////////////////////
// ,    
int segm::expandSegment( int iSegm, int iSegm0)	//   iSegm     1       iSegm0
{
	//this->saveText("expand0.txt");
	int noSegm = this->maximal()+1;		//   
	int size = changeVal(iSegm, noSegm);
	//this->saveText("expand1.txt");
	if( size==0 ) return 0;

	int cnt=0;
	for( int y=0; y<my; y++ )
	for( int x=0; x<mx; x++ )
	{
		if( get(x,y) != iSegm0 ) continue;
		if( isOutBorder4( x,y, noSegm) ){ put(x,y, iSegm); cnt++; }
	}
	//this->saveText("expand2.txt");
	changeVal( noSegm, iSegm );
	max = -1;							//    !
	return cnt;
}
//////////////////////////////////////////////////////////////////
int segm::expandSegments( int iSeg1, int iSeg2, int iSegm0)	//   iSeg1..iSeg2     1       iSegm0
{
	int x,y, x1,y1, cnt, is0, cnt2=0;
	//       :
	int mxmy = mx*my;					//   
	int iPnt0 = mxmy / 3;				//   
	int iPnt;							//  
	do {
		//cnt = this->countVal(iSegm0);
		cnt = 0;						//      
		iPnt = iPnt0;					
		x = iPnt % mx; 
		y = iPnt / mx;					// (x,y):=   
		do {
			if( get(x,y) != iSegm0 ) continue;	//    iSegm0 
			//   4-      iSeg1..iSeg2,  
			//        
			for( int k=0; k<8; k++ )			//   4-   
			{
				neighbor8(x,y, k, x1,y1);	// (x1,y1) -    (x,y)  k
				if( x1<0 || x1>=mx || y1<0 || y1>=my ) continue;//   
				is0 = get(x1,y1);			//   
				if( iSeg1<=is0 && is0<=iSeg2 )	 		//     - 
				{
					put(x,y, is0 );
					cnt ++;
					break;
				}
			}
			iPnt = Mnext(mxmy, iPnt);
			x = iPnt % mx;
			y = iPnt / mx;					// (x,y):=   
		} while( iPnt != iPnt0 );
		cnt2 += cnt;
	} while( cnt>0 );
	//cnt = this->countVal(iSegm0);
	max=-1;								//    !
	return cnt2;
} // int segm::expandSegments( int iSeg1, int iSeg2, int iSegm0)	//   iSeg1..iSeg2     1       iSegm0
//////////////////////////////////////////////////////////////////
int segm::decreaseSegment( int iSegm, int v)	//     iSegm    v
{
	pvector list;
	this->inBorder( iSegm, list );
	this->setByList( list, v);
	max=-1;								//    !
	return list.size();
}
//////////////////////////////////////////////////////////////////

int segm::decreaseSegments(int iSegm1, int iSegm2, int v) //    iSegm1..iSegm2    v
{
	pvector list;
	int s;
	for( int y=0; y<my; y++ )
	for( int x=0; x<mx; x++ )
	{
		s = this->get(x,y);
		if( s<iSegm1 || iSegm2<s ) continue;
		if( this->isBorder8(x,y) )
			list.add(x,y);
	}
	this->setByList( list, v);
	max=-1;								//    !
	return list.size();
}
//////////////////////////////////////////////////////////////////
// ,     - .
// 0      .
void	segm::kill_small_segments(int minSegSize)//   
{
	max = Max();
	for( int iSgm=1; iSgm<=max; iSgm++ )		//    
		if( countVal(iSgm) < minSegSize )		//   0- 
			changeVal(iSgm,0);

	int mx = Mx(), my=My();
	int x, y, x1, y1, k, v1, cnt;
	int mxmy = mx*my;					//   
	int iPnt0 = mxmy / 3;				//   
	int iPnt;
	do											//      
	{											//    - 
		cnt = 0;								//     (do{})   

		//     :
		//firsPoint( mx, my, x, y);		// (x,y):=   
		iPnt = iPnt0;
		x = iPnt % mx;
		y = iPnt / mx;					// (x,y):=   

		do {
			if( get(x,y) != 0 ) continue;	//    
			for( k=0; k<4; k++ )
			{
				neighbor( x,y, k, x1,y1);
				if( x1<0 || x1>=mx || y1<0 || y1>=my ) continue;
				v1 = get(x1,y1);			
				if( v1<= 0 ) continue;
				//  (x,y) \in Segm(0), (x1,y1) \in Segm(v1), v1>0.
				put(x,y, -v1);				//     v1
				cnt++;
				break;
			}
			iPnt = Mnext(mxmy, iPnt);
			x = iPnt % mx;
			y = iPnt / mx;					// (x,y):=   
		} while (iPnt != iPnt0);
		if( cnt==0 ) break;					//    ,   do{}
		for( int y=0; y<my; y++ )			//     :
		for( int x=0; x<mx; x++ )
		{
			v1 = get(x,y);
			if( v1<0) put(x,y,-v1);
		}
		//printf("#");
	} while(1); // do
	//sortBySize();
	max=-1;								//    !
} // void	segm::kill_small_segments(int minSegSize)//   
//////////////////////////////////////////////////////////////////
void segm::dSegm(pvector &list, histogr &h)	// com :=      list
{
	h.clear();
	for (int i = 0; i<list.size(); i++)
		h.add(get(list.getX(i), list.getY(i)));
}
//////////////////////////////////////////////////////////////////
void segm::dSegm(int x0, int y0, histogr &h)	// com :=      (x0,y0)
{
	h.clear();
	int xMin = (x0 == 0 ? 0 : x0 - 1);
	int xMax = (x0 == mx - 1 ? x0 : x0 + 1);
	int yMin = (y0 == 0 ? 0 : y0 - 1);
	int yMax = (y0 == my - 1 ? y0 : y0 + 1);

	for (int y = yMin; y <= yMax; y++)
		for (int x = xMin; x <= xMax; x++)
			if (x != x0 || y != y0)
				h.add(get(x, y));
}
//////////////////////////////////////////////////////////////////
//   .
//  list !=NULL,   list    
int segm::cellAutom1(int k, pvector *list)	//       k. 
{
	int cnt = 0;
	int x, y;
	histogr h;								//   
	if (list) list->clear();

	for (y = 0; y<my; y++)
		for (x = 0; x<mx; x++)
		{
			//printf("(x,y)=(%4d,%4d)\r", x,y);
			int s0 = get(x, y);				//   
			dSegm(x, y, h);					// com:=      
			int s1, cnt1;
			cnt1 = h.MaxCount(s1);			//  s1  cnt1  ( )
			if (cnt1 >= k) {		 		//      k    (s1)
				if (s1 != s0) {
					put(x, y, s1);			//        
					if (list) list->add(x, y);
					cnt++;
				}
			}
		}
	return cnt;
}

//////////////////////////////////////////////////////////////////
//   .
//   list2 -   
int segm::cellAutom2(int k, pvector &list, pvector &list2)	//       k   . 
{
	int x, y;
	histogr h;								//   
	list2.clear();
	for (int i = 0; i<list.size(); i++)
	{
		x = list.getX(i);
		if (x < 0 || x >= mx) continue;
		y = list.getY(i);
		if (y < 0 || y >= my) continue;
		int s0 = get(x, y);				//   
		dSegm(x, y, h);					// com:=      
		int s1, cnt1;
		cnt1 = h.MaxCount(s1);			//  s1  cnt1  ( )
		if (cnt1 >= k) {		  		//      k    (com.iValue(0)),
			if (s1 != s0) {
				put(x, y, s1);			//       
				list2.add9(x, y);		//         
			}
		}
	}
	return list2.size();
} // int segm::cellAutom2(int k, pvector &list, pvector &list2 )	//       k   . 
//////////////////////////////////////////////////////////////////
//     8-  >= k   ,
//        
//    
int segm::cellAutom(int k)					//     k
{
	//printf("segm::cellAutom(%d)\n", k);
	int cnt, cnt1;							//        
	pvector list, list1;					//        
	cnt = cnt1 = 0;
	do {									//   -    ,   
		cnt1 = cellAutom1(k);
		cnt += cnt1;
		//printf("    cnt=%8d\n", cnt1);
	} while (cnt1>200);

	cnt += cellAutom1(k, &list);			//    

	do {									//   -  
		cnt1 = cellAutom2(k, list, list1);
		cnt += cnt1;
		list = list1;
		//printf("    cnt=%8d\n", cnt1);
	} while (cnt1>0);
	max = this->maximal();
	return cnt;
} // int segm::cellAutom(int k)					//     k
//-----------------------------------------------------------------------------
void	segm::getInfo(matr *a, matr3 *a3)		//    
{
	int kind = a3 ? 3 : a ? 1 : 0;					// 0 -  , 1 - matr a, 3 - matr3 a3
	this->sRelease();
	max = this->maximal();
	aSz = max + 1;								//  
	if (aSz<0 || aSz>30000) vError("segm::getInfo: nSgm=%d", max);

	area = new int[aSz];						//    
	midX = new double[aSz];						// (->)  X
	midY = new double[aSz];						// (->)  Y
	offs = new double[aSz];						// 
	double *midX2 = new double[aSz];			// (->)  X^2
	double *midY2 = new double[aSz];			// (->)  Y^2

	midR = new double[aSz];						//    
	midG = new double[aSz];						// 
	midB = new double[aSz];						// 
	top.setSize(max + 1, max + 1);
	ctop.setSizeClear(max + 1, max + 1);

	int i, x, y, k, x1, y1, s, s1;
	for (i = 0; i<aSz; i++) midX2[i] = midY2[i] = midX[i] = midY[i] = midR[i] = midG[i] = midB[i] = area[i] = 0;

	for (y = 0; y<my; y++)
		for (x = 0; x<mx; x++)
		{
			i = this->get(x, y);
			if (i<0) continue;
			area[i] ++;
			midX[i] += x;
			midY[i] += y;
			midX2[i] += x*x;
			midY2[i] += y*y;
			if (kind == 1)
				midR[i] += a->get(x, y);
			else if (kind == 3) {
				midR[i] += a3->r.get(x, y);
				midG[i] += a3->g.get(x, y);
				midB[i] += a3->b.get(x, y);
			}
			//   (top  ctop)

			for (k = 0; k <= 1; k++)
			{
				if (k == 0) { x1 = x + 1; y1 = y; }
				else { x1 = x; y1 = y + 1; }
				if (x1 == mx || y1 == my) continue;

				s = this->get(x, y);
				s1 = this->get(x1, y1);
				if (s == s1) continue;			//     
				if (s > s1) swapInt(s, s1);
				//  s<s1
				top.inc(s, s1, 1);
				top.inc(s, s, 1);
				top.inc(s1, s1, 1);
				int w = 0;
				if (kind == 1) w = abs(a->get(x, y) - a->get(x1, y1));
				else if (kind == 3) w = round(a3->dist(x, y, x1, y1));
				//if (brd.Mx() == mx) if (bord(x, y, k)) w *= 16;		//   (x,y)-(x1,y1)  ,  w  16 !
				ctop.inc(s, s1, w);
			}

		}
	double tmp;
	for (i = 0; i<aSz; i++)
	{
		if (area[i] == 0) continue;              //   
		tmp = midX[i]; tmp /= area[i];
		midX2[i] = midX2[i] / area[i] - tmp*tmp;
		midX[i] = tmp;

		tmp = midY[i]; tmp /= area[i];
		midY2[i] = midY2[i] / area[i] - tmp*tmp;
		midY[i] = tmp;

		offs[i] = sqrt(midX2[i] + midY2[i]);

	}
	delete[]midX2;
	delete[]midY2;
	// :     :
	for (y = 1; y <= max; y++)
		for (x = 0; x<y; x++)
		{
			s1 = top.get(x, y);
			top.put(y, x, s1);
			if (s1 == 0) continue;
			if (kind > 0) {									//    
				s = round(((double)ctop.get(x, y)) / s1);
				ctop.put(x, y, s);
				ctop.put(y, x, s);
			}
		}
}//void	segm::getInfo()				//    
//-----------------------------------------------------------------------------
int	 segm::Area(int iSegm)		//  
{
	if (iSegm<0 || iSegm>aSz) return 0;
	return area[iSegm];
}
double	 segm::MidX(int iSegm)
{
	if (iSegm<0 || iSegm>aSz) return 0;
	return midX[iSegm];
}
double	 segm::MidY(int iSegm)
{
	if (iSegm<0 || iSegm>aSz) return 0;
	return midY[iSegm];
}
double	 segm::Offs(int iSegm)
{
	if (iSegm<0 || iSegm>aSz) return 0;
	return offs[iSegm];
}
double	 segm::MidR(int iSegm)
{
	if (iSegm<0 || iSegm>aSz) return 0;
	return midR[iSegm];
}
double	 segm::MidG(int iSegm)
{
	if (iSegm<0 || iSegm>aSz) return 0;
	return midG[iSegm];
}
double	 segm::MidB(int iSegm)
{
	if (iSegm<0 || iSegm>aSz) return 0;
	return midB[iSegm];
}
//-----------------------------------------------------------------------------
double	segm::colDist(int iSegm1, int iSegm2)	//    
{
	if (iSegm1<0 || iSegm1>aSz) vError("segm::colDist(%d, %d)", iSegm1, iSegm2);
	if (iSegm2<0 || iSegm2>aSz) vError("segm::colDist(%d, %d)", iSegm1, iSegm2);
	return hypot3(midR[iSegm1] - midR[iSegm2], midG[iSegm1] - midG[iSegm2], midB[iSegm1] - midB[iSegm2]);
}
//-----------------------------------------------------------------------------
double	segm::colBDist(int iSegm1, int iSegm2)	//      
{
	if (max<0) vError("segm::colBDist(%d, %d)", iSegm1, iSegm2);
	if (ctop.Mx() == 0) vError("segm::colBDist(%d, %d)", iSegm1, iSegm2);
	if (iSegm1<0 || iSegm1>aSz) vError("segm::colBDist(%d, %d)", iSegm1, iSegm2);
	if (iSegm2<0 || iSegm2>aSz) vError("segm::colBDist(%d, %d)", iSegm1, iSegm2);
	double v = this->top.get(iSegm1, iSegm2);	//  
	if (v == 0) return 0;
	return this->ctop.get(iSegm1, iSegm2);
}
//-----------------------------------------------------------------------------
int		segm::bordSize(int iSegm1, int iSegm2)//     
{
	max = Max();
	if (top.Mx() == 0) vError("segm::bordSize(%d, %d): top==NULL", iSegm1, iSegm2);
	if (iSegm1<0 || iSegm1>max) vError("segm::bordSize(%d, %d)", iSegm1, iSegm2);
	if (iSegm2<0 || iSegm2>max) vError("segm::bordSize(%d, %d)", iSegm1, iSegm2);
	return this->top.get(iSegm1, iSegm2);
}
//////////////////////////////////////////////////////////////////
int segm::nearestB(int x0, int y0, int &x1, int &y1)	//   a   (x,y)  (x1,y1) -      
{
	int k = get(x0, y0);
	int dx = 0, dy = 0, x, y;
	for (int cnt = mx*my; cnt>=0; cnt--)
	{
		nextPoint(dx, dy);
		x = x0 + dx; y = y0 + dy;
		if (x<0 || x >= mx || y<0 || y >= my) continue;
		int k1 = get(x, y);
		if (k1 != k) { x1 = x; y1 = y; return k1; }
	};
	return -1;
} // int segm::nearestPositiveValue( matr &a, int x0, int y0, int &x1, int &y1)	//   a   (x,y)  (x1,y1) -     
//////////////////////////////////////////////////////////////////
void segm::saveInfo(char *fname)				//     fname
{
	if (aSz <= 0) getInfo();
	FILE *f = fopen(fname, "w");
	if (!f) vError("segm::saveStatist: file %s not open", fname);
	fprintf(f, "%4d %4d --\n", mx, my);
	for (int i = 0; i <= max; i++) {
		fprintf(f, "%4d: %8d mid(%6.1f, %6.1f)  ", i, area[i], midX[i], midY[i]);
		for (int j = 0; j <= max; j++) {
			if (j == i) continue;
			if (top.get(i, j) == 0) continue;
			fprintf(f, "<%4d: %4d %4d>", j, top.get(i, j), ctop.get(i, j));
		}
		fprintf(f, "\n");
	}
	fclose(f);
}
//-----------------------------------------------------------------------------

/*
//////////////////////////////////////////////////////////////////
// :
//           2   3   2
//           3   *   3
//           2   3   2
//
//     >= k   ,
//        
//    
int segm::cellAutomW(int k)					//     k    3-2 
{
	//printf("segm::cellAutom(%d)\n", k);
	int cnt, cnt1;							//        
	pvector list, list1;					//        
	cnt = cnt1 = 0;
	do {									//   -    
		cnt1 = cellAutom1(k);
		cnt += cnt1;
		//printf("    cnt=%8d\n", cnt1);
	} while (cnt1>200);

	cnt += cellAutom1(k, &list);			//    

	do {									//   -  
		cnt1 = cellAutom2(k, list, list1);
		cnt += cnt1;
		list.CopyFrom(list1);
		expandList(list, mx, my);
		//printf("    cnt=%8d\n", cnt1);
	} while (cnt1>0);
	max = this->maximal();
	return cnt;
} // int segm::cellAutom(int k)					//     k
//////////////////////////////////////////////////////////////////
void	segm::TopReduce( int kSegm )	//      ctop[i,j],       kSegm
{
	max = Max();
	if( max< kSegm ) return;
	int *asg = new int[max+1];			// asg[i] -  ,     i, asg[i] <= i
	for( int i=0; i<=max; i++ ) asg[i] = i;		//       
	const int MMAX = 999999999;
	ctop.changeVal(0, MMAX);
	for( int ns = max; ns>kSegm; ) {
		int i,j;
		int cmin = ctop.minimal(i,j);				// (i,j) -      ctop
		if( cmin == 0 ) break;						//  ,    ,      
		if( i>j ) { int tmp=i; i=j; j=tmp; }		//  0 <= i < j <= nSegm
		//  j-   i-
		//printf("%3d) %3d %3d ", ns, i, j); 
		i = asg[i];	//	 i-     ,   j-    
		//printf("//%3d cmin = %3d\n", i, cmin); 
		//  ,   j-,   i-
		for( int i1=0; i1<=max; i1++ )
			if( asg[i1]==j ) asg[i1] = i;

		ctop.fillColumn(j, MMAX);					//    "",      
		ctop.fillLine  (j, MMAX);
		ns--;
	}
	//    .     
	int x,y, s, s1;
	for( y=0; y<this->My(); y++ )
	for( x=0; x<this->Mx(); x++ )
	{
		s = this->get(x,y);
		s1= asg[s];
		if( s1==s) continue;
		put(x,y,s1);						//   s-   s1-
	}
	//minimizeIndexes();						//    
	sortBySize();
}//void	segm::TopReduce( int kSegm )	//      ctop[i,j],       kSegm
//////////////////////////////////////////////////////////////////
void expandList( pvector &list, int mx, int my )	//   list    
{
	int x,y, x1,y1, k;
	list.setUniq(1);						//   
	for( int i=list.getSize()-1; i>=0; i++ ) {
		x = list.getX(i);
		y = list.getY(i);
		for( k=0; k<8; k++ )
		{
			neighbor8(x,y,k, x1,y1);
			if( x1<0 || x1>=mx || y1<0 || y1>=my ) continue;	//    
			list.AddPoint(x1, y1);			//  ,    
		}
	}
}

//////////////////////////////////////////////////////////////////
void deleteBorderFromList( segm &sgm, pvector &list, int v, int type ) //  4(8)-      v
{
	pvector list_del;						//   
	int x, y, i;
	for( i=list.getSize()-1; i>=0; i-- ) 
	{
		x = list.getX(i);
		y = list.getY(i);
		if( (type==4 && sgm.isBorder4(x,y)) || 
			(type==8 && sgm.isBorder8(x,y)) ) 
		{
			//sgm.put(x,y, v);				//      
											// !!   .      
			list_del.AddPoint(x,y);			//       list_del
			list.DeletePoints(i,i);			//     list
		}
	}
	sgm.setByList(list_del, v);				//      v
} // void deleteBorderFromList( segm &sgm, pvector list, int v, int type ) //  4(8)-      v

//////////////////////////////////////////////////////////////////
void	drawSegments_( segm &sgm, char *bmpname, int s0, int s1 )	//   s0..s1    
{
	int mx=sgm.Mx(), my=sgm.My();
	matr rgb(mx,my);	//      
	int s, cr, cg, cb;
	for( int y=0; y<my; y++ )
	for( int x=0; x<mx; x++ )
	{
		s = sgm.get(x,y);
		if( s<s0 || s>s1 ) continue;
		rSegmentColor(s, cr,cg,cb);
		rgb.put(x,y, rgb_int(cr,cg,cb));
	}
	rgb.saveBMP(bmpname);
} // void	drawSegments_( char *bmpname, int s0, int s1 )	//   s0..s1    

//-----------------------------------------------------------------------------
//void matrixNormalizationQ( matr  &a, int k, double p0, double p1 )	//       [0..k]
//{
//	int q0, q1;						//      p0, p1
//	Quantile( a, p0, q0, p1, q1);	//  q0, q1
//	a.clip( q0, q1);				//    -   [q0..q1]
//	a.normalize(k);					//    -
//}
//-----------------------------------------------------------------------------

int		segm::Neib( int iSegm, int k )	//   iSegm   k (    )
{
	if( max<0 ) vError("segm::neighbor(%d, %d): nSgm=%d", iSegm, k, nSgm);
	if( neib.Mx()==0 ) vError("segm::neighbor(%d, %d): top==NULL", iSegm, k);
	if( iSegm<0 || iSegm>nSgm ) vError("segm::neighbor(%d, %d)", iSegm, k);
	if( k<0 || k>nSgm ) vError("segm::neighbor(%d, %d)", iSegm, k);

	return this->neib.get(k, iSegm);
}

//////////////////////////////////////////////////////////////////
// 1.   i1..i2   
// 2. ,   minSegSize   i1 (..   )
//=================================================
// !!!!!!!!!!!!!!!  !!!!!!!!!!!!!!!!!!!!!!!
//  -     .
//     
//=================================================
void segm::specSort( int i1, int i2, int minSegSize)	//      split
{
	this->sortBySize(i1, i2);
	int NN = i2-i1+1;
	int *area = new int[NN];
	this->areas(i1, i2, area);
	int j;
	for( j=0; j<NN; j++)
		if( area[j]<minSegSize ) break;
	// i1+j -      
	if( j<NN ) this->changeVal2(i1+j, i2, i1 );
}
//-----------------------------------------------------------------------------
int segm::splitRad( int i, int rad, int minSegSize)	//   i      rad.   
{
	int nSegm0 = this->maximal()+1;					//   
	int nSegm = nSegm0;
	int rad2 = rad*rad;
	int x,y, x0, y0, sz, cnt=1;
	do 
	{
		x0=y0=-1;
		for( y=0; y<my; y++ )
		for( x=0; x<mx; x++ )
			if( this->get(x,y)==i ) {x0=x; y0=y; break; }
		if( x0<0 ) break;							//  
		// (x0,y0) -     i
		//    ,   (x0,y0)    nSegm
		sz=0;
		for( y=0; y<my; y++ )
		for( x=0; x<mx; x++ )
			if( this->get(x,y)==i && (iSquare(x-x0)+iSquare(y-y0))>rad2 ) 
			{ 
				this->put(x,y, nSegm); 
				sz++; 
			}
		// :    ,   (x0,y0)    nSegm
		if(sz==0) break;		//   , 
		if(sz<minSegSize)		//  .     
		{
			this->changeVal(nSegm, i);
			break;
		}
		cnt ++;
		i = nSegm++;
		//this->saveStatist("stat.txt");
	} while(sz>0);
	//     nSegm0, ... nSegm-1
	this->specSort(nSegm0, nSegm-1, minSegSize);
	max = this->maximal();
	return cnt;
}//int segm::splitRad( int i, int rad, int minSegSize)	//   i      rad.   
//-----------------------------------------------------------------------------
//////////////////////////////////////////////////////////////////
static int connectSize( segm &sgm, int x, int y, int type ) //  4(8)-   
{
	pvector list;
	int s = sgm.get(x,y);			//  
	int size = sgm.connectRegion( x, y, INT_MAX, type, &list ); 
	sgm.setByList( list, s);		//     
	return size;
} // static int connectSize( segm &sgm, int x, int y, int type ) //  4(8)-   
//////////////////////////////////////////////////////////////////
//   2010-01-17
//   i  .   
//     
// i, max+1, max+2, ..., max+k-1
//  max -      ,
//     k   -  ,     ,
// type = 4|8 -   4   8  
//    .
// :    ,    dStep ,      
//     ,    .
//     -    ( 1).
//   ,       
//        .
int segm::split( int i, int dStep, int type, int minSegSize)//   i   (dStep  ).   
{
	int zeroSegm = -1;					// ,  
	pvector list0, list;
	this->getList( list, i);			//    
	if( list.size()<2*minSegSize ) return 1;//   ,  
	list0 = list;						//    
	int iStep=0;
	//drawSegments_(*this, "tmp.bmp", i, i);
	while(connectSize( *this, list.getX(0), list.getY(0), type) == list.getSize()) //        
	{
		//printf("-");
		deleteBorderFromList( *this, list, zeroSegm, type);
		//drawSegments_(*this, "tmp.bmp", i, i);
		if( list.size()<8 ) { iStep=-1; break; }
		if( iStep++==dStep)	   { iStep=-1; break; }
		//printf("*");
	}
	if( iStep<0 ) //   
	{
		this->setByList(list0, i);
		return 1;
	}
	// list0 -    
	// list  -   ""  (  ),    
	//  ""     zeroSegm;
	//drawSegments_(*this, "tmp.bmp", i, i);
	//saveStatist("stat.txt");
	//vShow("split(%d), size=%d\n", i, list0.getSize() );

	int j, x, y, s1, nSegm;
	max = Max();
	nSegm = max+1;					//   
	s1 = nSegm;
	for( j=0; j<list.getSize(); j++ )
	{
		x = list.getX(j);						//  
		y = list.getY(j);
		if( this->get(x,y)>=nSegm ) continue;	//       
		this->connectRegion(x,y, s1++, type);	//    (x,y)    s1
	}
	this->expandSegments(nSegm, s1-1, zeroSegm);	
	//      ( s1-1)      i
	this->changeVal(s1-1,i);
	//            :
	int nSegm2 = this->maximal()+1;
	this->split(i, dStep, type, minSegSize);
	for( j=nSegm; j<nSegm2; j++ )
		this->split(j, dStep, type, minSegSize);
	//    
	max = maximal();
	return max - nSegm;
} // int segm::split( int i, int dStep, int type)//   i   (dStep  ).   
//////////////////////////////////////////////////////////////////
//     ----------------------------------------------
//////////////////////////////////////////////////////////////////
//              3
//            2 * 0
//              1
bool segm::bord(int x, int y, int k)		//      (x,y)   k (k=0|1|2|3)
{
brd.testIndexes(x, y);
if (k == 0) return brd.get(x, y) & 1;		// 
if (k == 1) return brd.get(x, y) & 2;		// 
if (k == 2) {								// 
if (x == 0) return true;
return brd.get(x - 1, y) & 1;
}
if (k == 3) {								// 
if (y == 0) return true;
return brd.get(x, y - 1) & 2;
}
return false;
vError("segm::bord: k=%d", k);
}
//////////////////////////////////////////////////////////////////
bool segm::bord(int x1, int y1, int x2, int y2)		//      (x1,y1)  (x2,y2)
{
if (x1 == x2) {									//   
if (y2 == y1 + 1) return bord(x1, y1, 1);
if (y2 == y1 - 1) return bord(x1, y1 - 1, 1);
return false;
}
if (y1 == y2) {									//   
if (x2 == x1 + 1) return bord(x1, y1, 0);
if (x2 == x1 - 1) return bord(x1 - 1, y1, 0);
return false;
}
return false;
}
//////////////////////////////////////////////////////////////////
void segm::bord_init() { brd.setSizeClear(mx, my); }				//  
// 0 -    ,     (x,y)
// 1 -   ,  - 
// 2 -   ,  - 
// 3 -    ,  
void segm::bord_set(int x, int y, int k)	//    (k=0)   (k=1)   (x,y)
{
	brd.testIndexes(x, y);
	int b = this->brd.get(x, y);
	if (k == 0)  this->brd.put(x, y, b | 1);
	else if(k==1) this->brd.put(x, y, b | 2);
	else vError("segm::bord_set: k=%d", k);
}
//////////////////////////////////////////////////////////////////

*/