// substs.cpp Substitions
//
#pragma warning(disable : 4996)
#include <stdlib.h>
#include <string.h>
#include <vector>
using namespace std;
extern void    vError(const char *format, ...); // show error function

#include "substs.h"			// 


static unsigned long long facto[21] = {
                  1, //  0
				  1, //  1
				  2, //  2
				  6, //  3
				 24, //  4
				120, //  5
			    720, //  6
			   5040, //  7
			  40320, //  8
			 362880, //  9
            3628800, // 10
           39916800, // 11
          479001600, // 12
         6227020800, // 13
        87178291200, // 14
      1307674368000, // 15
     20922789888000, // 16 
    355687428096000, // 17
   6402373705728000, // 18
 121645100408832000, // 19
2432902008176640000, // 20
};

unsigned factorial(int n)	// n!
{
	if (n<0 || n>12) vError("factorial: n=%d");
	//unsigned res = 2;
	//for (int i = 3; i <= n; i++) res *= i;
	//return res;
	return (unsigned)facto[n];
}
unsigned long long factorial64(int n)	// n!
{
	if (n<0|| n>20) vError("factorial: n=%d");
	//unsigned long long res = 2;
	//for (int i = 3; i <= n; i++) res *= i;
	//return res;
	return  facto[n];
}
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// barray,  
// constructors/destructors
//-----------------------------------------------------------------------------
barray::barray(int n_)
{
	if (n_ == 0) {
		n = 0;
		a = NULL;
		return;
	}
	if (n_>256) vError("barray::barray: n_ =%d", n_);
	n = n_;
	a = new BYTE[n];
	for (int i = 0; i<n; i++) a[i] = 0;
}
barray::~barray()
{
	if (n <= 0) return;
	if (a != NULL) delete[]a;
	a = NULL;
	n = 0;
}
//-----------------------------------------------------------------------------
void barray::setN(int n_)			// setSize
{
	if (n_ == n) return;
	if(a != NULL) delete[] a;
	n = n_;
	a = new BYTE[n];
}
//-----------------------------------------------------------------------------
BYTE &barray::operator[] (int i)
{
	if (i<0 || i >= n) vError("barray::Index =%d", i);
	return a[i];
}
//-----------------------------------------------------------------------------
void barray::setA(BYTE *a1)		// copy from array
{
	for (int i = 0; i<n; i++) a[i] = a1[i];
}
//-----------------------------------------------------------------------------
void barray::copyFrom(const barray &s)	// this := copyFrom(s)
{
	if (n != s.n)
	{
		delete[] a;
		n = s.n;
		a = new BYTE[n];
	}
	for (int i = 0; i<n; i++) a[i] = s.a[i];
}
//-----------------------------------------------------------------------------
void barray::set(BYTE v0, BYTE v1)
{
	setN(2);
	a[0] = v0;
	a[1] = v1;
}
void barray::set(BYTE v0, BYTE v1, BYTE v2)
{
	setN(3);
	a[0] = v0;
	a[1] = v1;
	a[2] = v2;
}
void barray::set(BYTE v0, BYTE v1, BYTE v2, BYTE v3)
{
	setN(4);
	a[0] = v0;
	a[1] = v1;
	a[2] = v2;
	a[3] = v3;
}
void barray::set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4)
{
	setN(5);
	a[0] = v0;
	a[1] = v1;
	a[2] = v2;
	a[3] = v3;
	a[4] = v4;
}
void barray::set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4, BYTE v5)
{
	setN(6);
	a[0] = v0;
	a[1] = v1;
	a[2] = v2;
	a[3] = v3;
	a[4] = v4;
	a[5] = v5;
}
void barray::set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4, BYTE v5, BYTE v6)
{
	setN(7);
	a[0] = v0;
	a[1] = v1;
	a[2] = v2;
	a[3] = v3;
	a[4] = v4;
	a[5] = v5;
	a[6] = v6;
}
void barray::set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4, BYTE v5, BYTE v6, BYTE v7)
{
	setN(8);
	a[0] = v0;
	a[1] = v1;
	a[2] = v2;
	a[3] = v3;
	a[4] = v4;
	a[5] = v5;
	a[6] = v6;
	a[7] = v7;
}
void barray::set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4, BYTE v5, BYTE v6, BYTE v7, BYTE v8)
{
	setN(9);
	a[0] = v0;
	a[1] = v1;
	a[2] = v2;
	a[3] = v3;
	a[4] = v4;
	a[5] = v5;
	a[6] = v6;
	a[7] = v7;
	a[8] = v8;
}
void barray::set(BYTE v0, BYTE v1, BYTE v2, BYTE v3, BYTE v4, BYTE v5, BYTE v6, BYTE v7, BYTE v8, BYTE v9)
{
	setN(10);
	a[0] = v0;
	a[1] = v1;
	a[2] = v2;
	a[3] = v3;
	a[4] = v4;
	a[5] = v5;
	a[6] = v6;
	a[7] = v7;
	a[8] = v8;
	a[9] = v9;
}
//-----------------------------------------------------------------------------
bool barray::isEqual(barray &s)				// this == s?
{
	if (n != s.n) vError("barray::isEqual(n!=s.n);");
	for (int i = 0; i<n; i++)
	{
		if (a[i] != s.a[i]) return false;
	}
	return true;
}
int  barray::compare(const barray &s2)			//  
{
	if (n != s2.n) vError("barray::compare(n!=s2.n);");
	for (int i = 0; i<n; i++)
	{
		int d = (int)a[i] - s2.a[i];
		if (d) return d;
	}
	return 0;
}

bool barray::operator< (const barray &s)	// 
{
	return compare(s)<0;
}

int  compareBA(const void *s1, const void *s2)			//  
{
	barray *b1 = (barray*)s1;
	barray *b2 = (barray*)s2;
	int n = b1->getN();
	if (n != b2->getN()) vError("barray::compare(s1->n!=s2->n);");
	for (int i = 0; i<n; i++)
	{
		int d = (int)((*b1)[i]) - (*b2)[i];
		if (d) return d;
	}
	return 0;
}
//-----------------------------------------------------------------------------
bool barray::operator==(barray &s)				// this == s?
{
	return isEqual(s);
}
//-----------------------------------------------------------------------------
char subst_toString[512];
char *barray::toString()
{
	char *s = subst_toString;
	for (int i = 0; i < n; i++) {
		if(a[i]<10)	s[i] = 48 + a[i];
		else        s[i] = 87 + a[i];	// abc...
	}
	s[n] = 0;
	return subst_toString;
}
//-----------------------------------------------------------------------------
bool barray::isSubs()						// all elements are different
{
	for (int i = 1; i<n; i++)
	{
		BYTE ai = a[i];
		if (ai<0) return false;
		if (ai >= n) return false;
		for (int j = 0; j<i; j++)
		{
			if (ai == a[j]) return false;
		}
	}
	return true;
}
//-----------------------------------------------------------------------------
static int compareBYTES(const void * x1, const void * x2)   //    
{
	//return (*(int*)x1 - *(int*)x2);              //     0,   , < 0: x1 < x2; > 0: x1 > x2
	return (*(BYTE*)x2 - *(BYTE*)x1);              //     0,   , < 0: x2 < x1; > 0: x2 > x1
}
void barray::sort()		// (22031) -> (32210)
{
	//bool done;
	//do {
	//	done = true;
	//	for (int i = 1; i<n; i++)
	//		if (a[i - 1]<a[i])
	//		{
	//			BYTE t = a[i - 1]; a[i - 1] = a[i]; a[i] = t; done = false;
	//		}
	//} while (!done);
	qsort(a, n, 1, compareBYTES);
}
//-----------------------------------------------------------------------------
void barray::swap(barray &s)				// this <-> s
{
	for (int i = 0; i < n; i++) {
		BYTE t = a[i]; a[i] = s.a[i]; s.a[i] = t;
	}
}
//-----------------------------------------------------------------------------
int  barray::fromString(char *s)			//      0..9
{
	BYTE b[256];
	int m;
	for (m = 0; m < 256; s++) {
		char ch = *s;
		if (ch == ' ' || ch == '\t' || ch == ',') continue;
		if ('0' <= ch && ch <= '9') {
			b[m++] = ch - '0';
			if (m >= 256) break;
			continue;
		}
		// ch     . 
		break;
	}
	//  m .
	setN(m);
	for (int i = 0; i < n; i++) a[i] = b[i];
	return n;
}
//-----------------------------------------------------------------------------
// constructors/destructors
//-----------------------------------------------------------------------------
subs::subs(int n_) {
	if (n_ == 0) {
		n = 0;
		if (a) delete[]a;
		a = NULL;
		return;
	}
	if (n_>256) vError("barray::barray: n_ =%d", n_);
	n = n_;
	if (a) delete[] a;
	a = new BYTE[n];
	for (int i = 0; i<n; i++) a[i] = i;
}
subs::subs(const subs &a)
{
	copyFrom(a);
}
//-----------------------------------------------------------------------------
char *subs::toStringS()					//   
{
	if (n >= 128) vError("subs::toStringS: n>=128");
	if (!isSubs()) vError("subs::toStringS: !isSubs");
	if (isE()) {
		subst_toString[0] = 'I';
		subst_toString[1] = 'd';
		subst_toString[2] = 0;
		return subst_toString;
	}
	char *s = subst_toString;
	//for (int i = 0; i < n; i++) {
	//	if (a[i]<10)	s[i] = 48 + a[i];
	//	else        s[i] = 87 + a[i];	// abc...
	//}
	//s[n] = 0;

	//      s.
	//      128.
	//  n   < 128!
	for (int i = 0; i<n; i++)
	{
		int ai = a[i];						//    
		if (ai >= 128) continue;
		if (ai == i) {						//    1,   
			a[i] += 128;
			continue;
		}
		a[i] += 128;
		//    >=2.
		//     i.       >= 128!
		*s++ = '(';							//   -  
		*s++ =  i < 10 ? 48 +  i : 87 +  i; //   i -  !
		int ai0 = ai;						//   ,     
		while (ai != i)
		{
			*s++ = ai<10 ? 48+ai : 87+ai;	//  -  !
			BYTE t = a[ai];
			a[ai] += 128;
			ai = t;
		}
		//  !
		*s++ = ')';							//   -  
	}
	*s = 0;									//  
	for (int i = 0; i<n; i++) a[i] -= 128;	//    s

	return subst_toString;

}
//-----------------------------------------------------------------------------
void subs::setId(int n_)
{
	if(n_>0 && n != n_) setN(n_);
	for (int i = 0; i<n; i++) a[i] = i;
}
//-----------------------------------------------------------------------------
void subs::mult(subs &s1, subs &s2)		// this := s1*s2
{
	int n = s1.n;
	if (s2.n != n) vError("subs1::mult(s1.n != s2.n);");

	BYTE btmp[256];					//    
	for (int i = 0; i<n; i++)
	{
		BYTE s2i = s2.a[i];
		if (s2i<0) vError("subs1::mult(s2i<0);");
		if (s2i >= n) vError("subs1::mult(s2i>=n);");
		btmp[i] = s1.a[s2i];
	}
	setN(n);
	for (int i = 0; i < n; i++) a[i] = btmp[i];
}
//-----------------------------------------------------------------------------
// t3.div(t1,t2); t4.mult(t3,t2); t4==t1
void subs::div(subs &s1, subs &s2)		// this := s1/s2
{
	int n = s1.n;
	if (s2.n != n) vError("subs1::mult(s1.n != s2.n);");

	BYTE btmp[256];					//    
	for (int i = 0; i<n; i++)
	{
		BYTE s2i = s2.a[i];
		BYTE s1i = s1.a[i];
		//if (s2i<0) vError("subs1::mult(s2i<0);");
		//if (s2i >= n) vError("subs1::mult(s2i>=n);");
		btmp[s1i] = s2i;
	}
	setN(n);
	for (int i = 0; i < n; i++) a[i] = btmp[i];
}
//-----------------------------------------------------------------------------
void subs::revers(subs &s)				// this := 1/s
{
	BYTE btmp[256];					//    
	setN(s.n);
	for (int i = 0; i<n; i++) btmp[i] = 255;

	for (int i = 0; i<n; i++)
	{
		BYTE si = s.a[i];
		if (si >= n) vError("subs::revers(si>=n);");
		btmp[si] = i;
	}

	for (int i = 0; i < n; i++) {
		BYTE bi = a[i] = btmp[i];
		if (bi == 255) vError("subs1::revers(a[i]==255);");
	}
}
//-----------------------------------------------------------------------------
bool subs::isCommut(subs &s)			// s*this=this*s?
{
	for (int i = 0; i<n; i++)
	{
		BYTE si = s.a[i];
		if (si >= n) vError("subs1::isCommut(si>=n);");
		BYTE ti = a[i];
		if (ti >= n) vError("subs1::isCommut(ti>=n);");

		if (a[si] != s.a[ti]) return false;
	}
	return true;
}
//-----------------------------------------------------------------------------
bool subs::isH()				// without stable point
{
	for (int i = 0; i<n; i++)
	{
		if (a[i] == i) return false;
	}
	return true;
}
//-----------------------------------------------------------------------------
unsigned subs::index()					// index of substitution
{
	if (n>12) vError("subs::index(n>12);");
	unsigned v, ai, cnt, fact;
	int i, j;
	BYTE s[12];
	for (i = 0; i<n - 1; i++)
	{
		ai = a[i];
		cnt = ai;
		//   cnt   ,  a[i]
		for (j = 0; j<i; j++) if (a[j]<ai) cnt--;
		s[i] = cnt;
	}
	//  n=6:
	// index = 5!*s[0] + 4!*s[1] + 3!*s[2] + 2!*s[3] + s[4]
	fact = 1;
	v = 0;
	for (i = n - 2; i >= 0; i--)
	{
		v += s[i] * fact;
		fact *= n - i;
	}
	return v;
}
//-----------------------------------------------------------------------------
unsigned long long subs::index64()		// index of substitution
{
	if (n>20) vError("subs::index64(n>20);");
	unsigned long long v, fact;
	unsigned  ai, cnt;
	int i, j;
	BYTE s[20];
	for (i = 0; i<n - 1; i++)
	{
		ai = a[i];
		cnt = ai;
		//   cnt   ,  a[i]
		for (j = 0; j<i; j++) if (a[j]<ai) cnt--;
		s[i] = cnt;
	}
	//  n=6:
	// index = 5!*s[0] + 4!*s[1] + 3!*s[2] + 2!*s[3] + s[4]
	fact = 1;
	v = 0;
	for (i = n - 2; i >= 0; i--)
	{
		v += s[i] * fact;
		fact *= n - i;
	}
	return v;
}
//-----------------------------------------------------------------------------
static int setByIndex_f(BYTE *w, int n, unsigned ind)
{
	for (int i = 0; i<n; i++)
	{
		if (w[i]>0) continue;
		if (ind == 0) return i;
		ind--;
	}
	return -1;
}
//-----------------------------------------------------------------------------
void subs::setByIndex(unsigned ind)			// this := substitution number ind
{
	if (n>12) vError("subs::setByIndex(n>12);");
	if( ind >= factorial(n)) vError("subs::setByIndex(ind>n!);");
	BYTE s[12];
	BYTE w[12];
	unsigned fact;
	int i;
	s[n - 1] = 0;
	for (i = n - 2; i >= 0; i--)
	{
		fact = n - i;
		s[i] = ind % fact;
		ind /= fact;
	}
	// s[i] -  i-       
	for (i = 0; i<n; i++) w[i] = 0;		// a[i]=0,   i   
	for (i = 0; i<n; i++)
	{
		int ai = setByIndex_f(w, n, s[i]);
		w[ai] = 1;
		a[i] = ai;
	}
}
//-----------------------------------------------------------------------------
void subs::setByIndex64(unsigned long long ind)	// this := substitution number ind,  n<=20
{
	if (n>20) vError("subs::setByIndex64(n>20);");
	if (ind >= factorial64(n)) vError("subs::setByIndex(ind>n!);");
	BYTE s[20];
	BYTE w[20];
	unsigned fact;
	int i;
	s[n - 1] = 0;
	for (i = n - 2; i >= 0; i--)
	{
		fact = n - i;
		s[i] = (BYTE) (ind % fact);
		ind /= fact;
	}
	// s[i] -  i-       
	for (i = 0; i<n; i++) w[i] = 0;		// a[i]=0,   i   
	for (i = 0; i<n; i++)
	{
		int ai = setByIndex_f(w, n, s[i]);
		w[ai] = 1;
		a[i] = ai;
	}
}
//-----------------------------------------------------------------------------
bool subs::isE()							// this = id
{
	for (int i = 0; i<n; i++)
	{
		if (a[i] != i) return false;
	}
	return true;
}
//-----------------------------------------------------------------------------
bool subs::isSim(subs &s)				// this/s   ?
										//  , ,  this[i] != a[i]   i
{
	if (n != s.n) vError("subs::isSim(n!=s.n);");
	for (int i = 0; i<n; i++)
	{
		if (a[i] == s.a[i]) return false;
	}
	return true;
}
//-----------------------------------------------------------------------------
int  subs::fixCount()		//   
{
	int cnt = 0;
	for (int i = 0; i<n; i++)
	{
		if (a[i] == i) cnt++;
	}
	return cnt;
}
//-----------------------------------------------------------------------------
void subs::stype(barray &ba)				// ba:=     this,   s=(01)(2)(3456)(78)(9),  this=(422110000)
{
	if (n >=128) vError("subs::stype: n>=128");
	if( !isSubs()) vError("subs::stype: !isSubs");
	ba.setN(n);
	int c = 0;	// cycle number
	for (int i = 0; i<n; i++) ba[i] = 0;
	//      s.
	//      128.
	//  n   < 128!
	for (int i = 0; i<n; i++)
	{
		if (a[i] >= 128) continue;
		//     i.       >= 128!
		int ai = a[i];						//    
		a[i] += 128;
		int cl = 1;							//  
		while (ai != i)
		{
			unsigned char t = a[ai];
			a[ai] += 128;
			ai = t;
			cl++;
		}
		ba[c++] = cl;						//   
	}
	for (int i = 0; i<n; i++) a[i] -= 128;	//    s
	ba.sort();								//     
}
//-----------------------------------------------------------------------------
int				   nKind(int n)			//     
{		       //  0,1,2,3,4,5,6,7,8,9,10
	int ar[11] = { 0,1,1,1,2,2,4,4,7,8,12 };
	if (n<0 || n >= 11) return -1;
	return ar[n];
}
//-----------------------------------------------------------------------------
//   
int  subs::itype()						//   
{
	if (!isH()) return -1;				//     .    !
	if (n <= 3) return 0;
	barray knd;
	//knd.stype(*this);
	this->stype(knd);
	BYTE *ka = &knd[0];
	if (n == 4) //  22->0, 4->1
	{
		return ka[0] == 2 ? 0 : 1;
	}
	if (n == 5) //  32->0, 5->1
	{
		return ka[0] == 3 ? 0 : 1;
	}
	if (n == 6) //  222->0, 42->1, 33->2, 6->3
	{
		return ka[0] == 6 ? 3 : ka[0] == 3 ? 2 : ka[0] == 4 ? 1 : 0;
	}
	if (n == 7) // 322->0, 52->1, 43->2, 7->3 
	{
		return ka[0] == 7 ? 3 : ka[0] == 4 ? 2 : ka[0] == 5 ? 1 : 0;
	}
	if (n == 8) // 2222->0, 422->1, 332->2, 62->3, 53->4, 44->5, 8->6
	{
		return ka[0] == 8 ? 6 : ka[0] == 5 ? 4 : ka[0] == 6 ? 3 : ka[0] == 6 ? 3 : ka[0] == 3 ? 2 : ka[0] == 2 ? 0 : ka[1] == 4 ? 5 : 1;
	}
	if (n == 9) // 3222->0, 522->1, 432->2, 72->3, 333->4, 63->5, 54->6, 9->7
	{
		return ka[0] == 9 ? 7 : ka[0] == 7 ? 3 : ka[0] == 6 ? 5 : ka[0] == 4 ? 2 : ka[1] == 4 ? 6 : ka[1] == 3 ? 4 : ka[0] == 3 ? 0 : 1;
	}
	if (n == 10) // 22222->0, 4222->1, 3322->2, 622->3, 532->4, 442->5, 82->6, 433->7, 73->8, 64->9, 55->10, (10)->11
	{		// 622->3, 64->9,
		return ka[0] == 10 ? 11 : ka[0] == 8 ? 6 : ka[0] == 7 ? 8 : ka[0] == 3 ? 2 : ka[0] == 2 ? 0 : ka[1] == 5 ? 10 : ka[0] == 5 ? 4 :
			ka[1] == 3 ? 7 : ka[3] == 2 ? 1 : ka[0] == 4 ? 5 : ka[1] == 2 ? 3 : 9;
	}
	return -1;
}
int  subs::itype(subs &s2)				//    this/s2
{
	subs s2r(n);
	s2r.div(*this, s2);
	return s2r.itype();
}
//-----------------------------------------------------------------------------
void subs::set_min(int k)	//    k
{
	if (n<2 || n>10)vError("subs1::set_min, n=%d", n);
	if (k<0 || k >= nKind(n)) vError("subs1::set_min(%d)", k);
	if (n == 2)
	{
		set(1, 0);
	}
	else if (n == 3)
	{
		set(1, 2, 0);
	}
	else if (n == 4)
	{
		if (k == 0) set(1, 0, 3, 2);
		else     set(1, 2, 3, 0);
	}
	else if (n == 5)
	{
		if (k == 0) set(1, 0, 3, 4, 2);
		else     set(1, 2, 3, 4, 0);
	}
	else if (n == 6)
	{
		if (k == 0) set(1, 0, 3, 2, 5, 4);
		else if (k == 1) set(1, 0, 3, 4, 5, 2);
		else if (k == 2) set(1, 2, 0, 4, 5, 3);
		else          set(1, 2, 3, 4, 5, 0);
	}
	else if (n == 7)
	{
		if (k == 0) set(1, 0, 3, 2, 5, 6, 4);
		else if (k == 1) set(1, 0, 3, 4, 5, 6, 2);
		else if (k == 2) set(1, 2, 0, 4, 5, 6, 3);
		else          set(1, 2, 3, 4, 5, 6, 0);
	}
	else if (n == 8)
	{
		if (k == 0) set(1, 0, 3, 2, 5, 4, 7, 6);
		else if (k == 1) set(1, 0, 3, 2, 5, 6, 7, 4);
		else if (k == 2) set(1, 0, 3, 4, 2, 6, 7, 5);
		else if (k == 3) set(1, 0, 3, 4, 5, 6, 7, 2);
		else if (k == 4) set(1, 2, 0, 4, 5, 6, 7, 3);
		else if (k == 5) set(1, 2, 3, 0, 5, 6, 7, 4);
		else          set(1, 2, 3, 4, 5, 6, 7, 0);
	}
	else if (n == 9)
	{
		if (k == 0) set(1, 0, 3, 2, 5, 4, 7, 8, 6);
		else if (k == 1) set(1, 0, 3, 2, 5, 6, 7, 8, 4);
		else if (k == 2) set(1, 0, 3, 4, 2, 6, 7, 8, 5);
		else if (k == 3) set(1, 0, 3, 4, 5, 6, 7, 8, 2);
		else if (k == 4) set(1, 2, 0, 4, 5, 3, 7, 8, 6);
		else if (k == 5) set(1, 2, 0, 4, 5, 6, 7, 8, 3);
		else if (k == 6) set(1, 2, 3, 0, 5, 6, 7, 8, 4);
		else          set(1, 2, 3, 4, 5, 6, 7, 8, 0);
	}
	else if (n == 10)
	{
		if (k == 0) set(1, 0, 3, 2, 5, 4, 7, 6, 9, 8);
		else if (k == 1) set(1, 0, 3, 2, 5, 4, 7, 8, 9, 6);
		else if (k == 2) set(1, 0, 3, 2, 5, 6, 4, 8, 9, 7);
		else if (k == 3) set(1, 0, 3, 2, 5, 6, 7, 8, 9, 4);
		else if (k == 4) set(1, 0, 3, 4, 2, 6, 7, 8, 9, 5);
		else if (k == 5) set(1, 0, 3, 4, 5, 2, 7, 8, 9, 6);
		else if (k == 6) set(1, 0, 3, 4, 5, 6, 7, 8, 9, 2);
		else if (k == 7) set(1, 2, 0, 4, 5, 3, 7, 8, 9, 6);
		else if (k == 8) set(1, 2, 0, 4, 5, 6, 7, 8, 9, 3);
		else if (k == 9) set(1, 2, 3, 0, 5, 6, 7, 8, 9, 4);
		else if (k == 10)set(1, 2, 3, 4, 0, 6, 7, 8, 9, 5);
		else             set(1, 2, 3, 4, 5, 6, 7, 8, 9, 0);
	}
}
//-----------------------------------------------------------------------------
// this := r*t/r
void subs::conj(subs &r, subs &t)
{
	//printf("r=%s\n", r.toString());
	//printf("t=%s\n", t.toString());
	if (!r.isSubs()) vError("subs::conj: r=", r.toString());
	if (!t.isSubs()) vError("subs::conj: t=", t.toString());
	if (r.n != t.n) vError("subs::conj(r.n != t.n);");
	setN(r.n);
	BYTE at[256];
	BYTE a2[256];
	for( int i=0; i<n; i++ ) at[r[i]] = i;		// at := 1/r
	for (int i = 0; i<n; i++) a2[i] = r[t[at[i]]];
	for (int i = 0; i<n; i++) a[i] = a2[i];
	//printf("conj=%s\n", this->toString());
	if( !isSubs()) vError("subs::conj: this=", this->toString());
}
//-----------------------------------------------------------------------------
//  ,    k-  (a[k])
int  subs::cycle_len(int k)
{
	int i = k, cnt = 0;
	do {
		i = a[i];
		cnt++;
	} while (i != k);
	return cnt;
}
//-----------------------------------------------------------------------------
// this := s such, that: t = s*r/s, 
bool subs::Find_conj(subs &r, subs &t)
{
	setN(r.n);
	int i, ordI, j, k;
	BYTE t1[256];
	for (i = 0; i < n; i++) t1[i] = t[i];	// t1 -  t.a
	for (i = 0; i < n; i++) a[i] = 255;		// this: a[*]=255
	for (i = 0; i < n; i++) {
		if (a[i] == 255) {
			ordI = r.cycle_len(i);			//  ,     r.a[i]
			for (j = 0; j < n; j++) {		//   t      ,     (t1[j]==0)
				if (t1[j] == 255) continue;
				if (t.cycle_len(j) == ordI) break;
			}
			if (j == n) return false;		//   ,   
			// Now r.cycle_len(i) == t.cycle_len(j)
			k = i;
			do {
				t1[j] = 255;  a[k] = j;  k = r[k];  j = t[j];
			} while (k != i);
		}
	}
	return true;
}
//-----------------------------------------------------------------------------
void subs::commut(vector<subs> &comm)	// comm :=  ,   this
{
	comm.clear();
	subs s(n);
	for (int i = factorial(n) - 1; i >= 0; --i) {
		s.setByIndex(i);
		if(isCommut(s))
			comm.push_back(s);
	}
}
//-----------------------------------------------------------------------------
void subs::cycles(vector<subs> &cycl)	// cycl :=  -,   this
{
	cycl.clear();
	subs t(n), s(n);
	t.copyFrom(*this);					// t -  this,   
	for (int i = 0; i < n; i++) {
		if (t[i] == 255) continue;
		s.setId();						//  s    
		int j = i;
		do {
			BYTE j0 = j;
			s[j] = t[j];
			j = t[j];
			if (j >= n) vError("subs::cycles: j>=n");
			t[j0] = 255;
		} while (j != i);
		//  s    
		cycl.push_back(s);
	}
}
//-----------------------------------------------------------------------------
bool subsSave(vector<subs> &v, const char *fname, char *msg)//    
{
	FILE *f = fopen(fname, "w");
	if (!f) return false;
	fprintf(f, "VECT_SUBS\nN=%d\nsize=%d, %s\n", v[0].getN(), (int)v.size(), msg);
	for (unsigned i = 0; i < v.size(); i++)
		//fprintf(f, "%s\n", v[i].toString());
		fprintf(f, "%llu\n", v[i].index64());
	fclose(f);
	return true;
}
bool subsLoad(vector<subs> &v, const char *fname)//    
{
	FILE *f = fopen(fname, "r");
	if (!f) return false;
	char buf[256];
	if (!fgets(buf, 256, f)) return false;
	if (strncmp(buf, "VECT_SUBS", 9) != 0) return false;
	int N;
	if (fscanf(f, "N=%d\n", &N) != 1) {
		vError("Illegal input");
		fclose(f);
		return false;
	}

	if (N<3 || N>20) {
		vError("Illegal N=%d", N);
		fclose(f);
		return false;
	}

	if (!fgets(buf, 256, f)) return false;		// size+msg

	int nZero = 0;								//  
	v.clear();
	subs s(N);

	do {
		unsigned long long k;
		if (fscanf(f, "%llu\n", &k) != 1) {
			//vError("Illegal input");
			fclose(f);
			return false;
		}
		if (k == 0) {
			if (++nZero > 1) {
				vError("Too many zeroes");
				fclose(f);
				return false;
			}
		}
		s.setByIndex64(k);
		v.push_back(s);
	} while (1);
	fclose(f);
	return true;
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------



