// u128.h : 16- 
//
#pragma warning(disable : 4996)

#include <stdio.h>
#include <stdlib.h>		// for lldiv
#include <intrin.h>

typedef unsigned __int64 u64;

bool even(u64 x);
bool odd(u64 x);

class u128 {
public:
	u64 a, b;			// a + b*2^64
	// constructors
	u128() { a = b = 0; }
	u128(u64 a_) { a = a_; b = 0; }
	u128(u64 a_, u64 b_) { a = a_; b = b_; }
	u128(const u128 &f) { a = f.a; b = f.b; }
	// ariphmetics -----------------------------------------------
	bool odd();
	void add(u64 a_);	// this += a_
	void add(u128 &f);	// this += f
	void mul(u64 a_);	// this *= a_
	void mul(u128 &f);	// this *= f
	int shift2s();		// divide by 2 till odd
	int log2(); 		// high bit index 0..127
	// operators ----------------------------------------------
	u128 u128::operator=(u64 a_);
	u128 u128::operator=(u128 &f);
	u128 u128::operator+(u64 a_);
	u128 u128::operator+(u128 &f);
	u128 u128::operator++();
	u128 u128::operator+=(u64 a_);
	u128 u128::operator+=(u128 &f);
	u128 u128::operator<<=(unsigned char x);		// multipyly by 2^x
	u128 u128::operator>>=(unsigned char x);		// divide by 2^x
	// power -------------------------------------------------
	void pow2(int n);								// this = 2^n
	void pow(u64 f, int n);							// this = f^n
	// subtract ---------------------------------------------
	u128 u128::operator--();
	u128 u128::operator-=(u64 a_);
	u128 u128::operator-=(u128 &f);
	u128 u128::operator-(u64 a_);
	u128 u128::operator-(u128 &f);
	// compare u128 ----------------------------------------
	bool u128::operator==(u128 &f);
	bool u128::operator!=(u128 &f);
	bool u128::operator<(u128 &f);
	bool u128::operator>(u128 &f);
	bool u128::operator<=(u128 &f);
	bool u128::operator>=(u128 &f);
	// compare u64----------------------------------------
	bool u128::operator==(u64 a_);
	bool u128::operator!=(u64 a_);
	bool u128::operator<(u64 a_);
	bool u128::operator>(u64 a_);
	bool u128::operator<=(u64 a_);
	bool u128::operator>=(u64 a_);
	// division -----------------------------------------------
	int div10(); 						// this /=10, returns remainder
	void div(u128 &f, u128 &d, u128&r);	// d = this/f, r = this%f !!slowly!!
	void div(u64 &f_, u128 &d, u128&r);	// d = this/f, r = this%f !!slowly!!
	u128 u128::operator/=(u64 a_);
	u128 u128::operator/=(u128 &f);
	u128 u128::operator/(u64 a_);
	u128 u128::operator/(u128 &f);
	u128 u128::operator%=(u64 a_);
	u128 u128::operator%=(u128 &f);
	u128 u128::operator%(u64 a_);
	u128 u128::operator%(u128 &f);
	// string ---------------------------------------------
	char *toString();
	char *toStringH();		// hex
	// 3n+1 --------------------------------------------------
	int ooStep();		// one step of (3n+1)-problem, from odd to odd, returns the number of division by 2
};

