// useful.cpp  ,    
// 2017-06-10

//
//#pragma warning(disable : 4996)
#pragma warning(disable: 4800) // 'int' : forcing value to bool 'true' or 'false'...

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <memory.h>
#include <limits.h>
#include <vector>
using namespace std;

#include "vUtil.h"			//   
#include "iMatrix.h"		//  
#include "iMatrix3.h"		//  3-
#include "pvectors.h"		//      
#include "BiQuadr.h"		//  
#include "vTransf.h"		//  
#include "dMatrix.h"		//  
#include "useful.h"			//  ,    

//-----------------------------------------------------------------------------
// list:=     N*M,   (x0,y0)
void   setListSQ(pvector &list, int x0, int y0, int N, int M)	// list:=   N*M,   (x0,y0)
{
	int y, iy, x, ix;
	list.clear();
	for (y = y0, iy = 0; iy < N; iy++, y += M + 1)
		for (x = x0, ix = 0; ix < N; ix++, x += M + 1)
			list.add(x, y);
}
//-----------------------------------------------------------------------------
void mShift1(matr &src, matr &dst, double vx, double vy)	// dst:= src   (vx,vy)
{
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
			dst.put(x, y, round(src.getInterp1(x + vx, y + vy)));
}
void mShift3(matr &src, matr &dst, double vx, double vy)	// dst:= src   (vx,vy) 
{
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
			dst.put(x, y, round(src.getInterp3(x + vx, y + vy)));
}
//-----------------------------------------------------------------------------
void mShift1(matr3 &src, matr3 &dst, double vx, double vy)	// dst:= src   (vx,vy)
{
	mShift1(src.r, dst.r, vx, vy);
	mShift1(src.g, dst.g, vx, vy);
	mShift1(src.b, dst.b, vx, vy);
}
void mShift3(matr3 &src, matr3 &dst, double vx, double vy)	// dst:= src   (vx,vy) 
{
	mShift3(src.r, dst.r, vx, vy);
	mShift3(src.g, dst.g, vx, vy);
	mShift3(src.b, dst.b, vx, vy);
}
//-----------------------------------------------------------------------------
void   trApply1(matr  &dst, matr  &src, CvTransf &tr)			// dst:=tr(src) 
{
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	double x1, y1;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			dst.put(x, y, round(src.getInterp1(x1, y1)));
		}
}
void   trApply3(matr  &dst, matr  &src, CvTransf &tr)			// dst:=tr(src) 
{
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	double x1, y1;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			dst.put(x, y, round(src.getInterp3(x1, y1)));
		}
}
//-----------------------------------------------------------------------------
void   trApply1(matr3 &dst, matr3 &src, CvTransf &tr)			// dst:=tr(src) 
{
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	double x1, y1;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			dst.put(x, y, round(src.r.getInterp1(x1, y1)),
				round(src.g.getInterp1(x1, y1)),
				round(src.b.getInterp1(x1, y1)));
		}
}
void   trApply3(matr3 &dst, matr3 &src, CvTransf &tr)			// dst:=tr(src) 
{
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	double x1, y1;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			dst.put(x, y, round(src.r.getInterp3(x1, y1)),
				round(src.g.getInterp3(x1, y1)),
				round(src.b.getInterp3(x1, y1)));
		}
}
//=============================================================================
// ,  S,   ()
//=============================================================================
double SCo = 1;
bool isSqrt = false;
void setMult(double coeff) { SCo = coeff; }	//  ,      S
void setSqrt(bool sqrt) {isSqrt = sqrt; }	//        S
double retS(double x) {
	x *= SCo;
	return isSqrt ? sqrt(x) : x;
}
//-----------------------------------------------------------------------------
double fSi(matr  &a, matr  &b, int vx, int vy, pvector &list)	// S     
{
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1 = b.safeGet(xa + vx, ya + vy) - a.get(xa, ya);
		S += s1*s1;
	}
	return retS(S / list.size());
}
double fSi(matr3 &a, matr3 &b, int vx, int vy, pvector &list)	// S     
{
	//return fSi(a.r, b.r, vx, vy, list) + fSi(a.g, b.g, vx, vy, list) + fSi(a.b, b.b, vx, vy, list);
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1r = b.r.safeGet(xa + vx, ya + vy) - a.r.get(xa, ya);
		double s1g = b.g.safeGet(xa + vx, ya + vy) - a.g.get(xa, ya);
		double s1b = b.b.safeGet(xa + vx, ya + vy) - a.b.get(xa, ya);
		S += s1r*s1r + s1g*s1g + s1b*s1b;
	}
	return retS(S / list.size());
}
//-----------------------------------------------------------------------------
double fSd1(matr  &a, matr  &b, double vx, double vy, pvector &list)// S       
{
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1 = b.getInterp1(xb, yb) - a.get(xa, ya);
		S += s1*s1;
	}
	return retS(S / list.size());
}
double fSd3(matr  &a, matr  &b, double vx, double vy, pvector &list)// S   	 
{
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1 = b.getInterp3(xb, yb) - a.get(xa, ya);
		S += s1*s1;
	}
	return retS(S / list.size());
}
double fSd1(matr3 &a, matr3 &b, double vx, double vy, pvector &list)// S       
{
	//return fSd1(a.r, b.r, vx, vy, list) + fSd1(a.g, b.g, vx, vy, list) + fSd1(a.b, b.b, vx, vy, list);
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1r = b.r.getInterp1(xb, yb) - a.r.get(xa, ya);
		double s1g = b.g.getInterp1(xb, yb) - a.g.get(xa, ya);
		double s1b = b.b.getInterp1(xb, yb) - a.b.get(xa, ya);
		S += s1r*s1r + s1g*s1g + s1b*s1b;
	}
	return retS(S / list.size());
}
double fSd3(matr3 &a, matr3 &b, double vx, double vy, pvector &list)// S   	 
{
	//return fSd3(a.r, b.r, vx, vy, list) + fSd3(a.g, b.g, vx, vy, list) + fSd3(a.b, b.b, vx, vy, list);
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1r = b.r.getInterp3(xb, yb) - a.r.get(xa, ya);
		double s1g = b.g.getInterp3(xb, yb) - a.g.get(xa, ya);
		double s1b = b.b.getInterp3(xb, yb) - a.b.get(xa, ya);
		S += s1r*s1r + s1g*s1g + s1b*s1b;
	}
	return retS(S / list.size());
}
//-----------------------------------------------------------------------------
double fS1Pnt(matr  &a, matr  &b, CvTransf &tr, int x, int y)		// S   
{
	double xb, yb;
	tr.apply(x, y, xb, yb); // tr(x,y) = (xb,yb)
	double t = b.getInterp1(xb, yb) - a.get(x, y);
	return retS(t*t);
}
double fS3Pnt(matr  &a, matr  &b, CvTransf &tr, int x, int y)		// S   
{
	double xb, yb;
	tr.apply(x, y, xb, yb); // tr(x,y) = (xb,yb)
	double t = b.getInterp3(xb, yb) - a.get(x, y);
	return retS(t*t);
}
double fS1Pnt(matr3 &a, matr3 &b, CvTransf &tr, int x, int y)		// S   
{
	double xb, yb;
	tr.apply(x, y, xb, yb); // tr(x,y) = (xb,yb)
	double t  = b.r.getInterp1(xb, yb) - a.r.get(x, y);
	double tg = b.g.getInterp1(xb, yb) - a.g.get(x, y);
	double tb = b.b.getInterp1(xb, yb) - a.b.get(x, y);
	return retS(t*t + tg*tg + tb*tb);
}
double fS3Pnt(matr3 &a, matr3 &b, CvTransf &tr, int x, int y)		// S   
{
	double xb, yb;
	tr.apply(x, y, xb, yb); // tr(x,y) = (xb,yb)
	double t = b.r.getInterp3(xb, yb) - a.r.get(x, y);
	double tg = b.g.getInterp3(xb, yb) - a.g.get(x, y);
	double tb = b.b.getInterp3(xb, yb) - a.b.get(x, y);
	return retS(t*t + tg*tg + tb*tb);
}
//-----------------------------------------------------------------------------
double fS1(matr  &a, matr  &b, CvTransf &tr, pvector &list)	// S   
{
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		tr.apply(xa, ya, xb, yb); // tr(x,y) = (xb,yb)
		double s1 = b.getInterp1(xb, yb) - a.get(xa, ya);
		S += s1*s1;
	}
	return retS(S / list.size());
}
double fS3(matr  &a, matr  &b, CvTransf &tr, pvector &list)	// S   
{
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		tr.apply(xa, ya, xb, yb); // tr(x,y) = (xb,yb)
		double s1 = b.getInterp3(xb, yb) - a.get(xa, ya);
		S += s1*s1;
	}
	return retS(S / list.size());
}
double fS1(matr3 &a, matr3 &b, CvTransf &tr, pvector &list)	// S   
{
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		tr.apply(xa, ya, xb, yb); // tr(x,y) = (xb,yb)
		double t = b.r.getInterp1(xb, yb) - a.r.get(xa, ya);
		double tg = b.g.getInterp1(xb, yb) - a.g.get(xa, ya);
		double tb = b.b.getInterp1(xb, yb) - a.b.get(xa, ya);
		S += t*t + tg*tg + tb*tb;
	}
	return retS(S / list.size());
}
double fS3(matr3 &a, matr3 &b, CvTransf &tr, pvector &list)	// S   
{
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		tr.apply(xa, ya, xb, yb); // tr(x,y) = (xb,yb)
		double t = b.r.getInterp3(xb, yb) - a.r.get(xa, ya);
		double tg = b.g.getInterp3(xb, yb) - a.g.get(xa, ya);
		double tb = b.b.getInterp3(xb, yb) - a.b.get(xa, ya);
		S += t*t + tb*tg + tb*tb;
	}
	return retS(S / list.size());
}
//-----------------------------------------------------------------------------
void saveArr(double *v, int mx, int my, char *fname, char *msg="")
{
	FILE *f = aopen(fname);
	fprintf(f, "Values of S, mx=%4d, my=%4d;  %s\n", mx, my, msg);
	for (int iy = 0; iy < my; iy++) {
		fprintf(f, "%4d:", iy);
		for (int ix = 0; ix < mx; ix++) {
			fprintf(f, "%8.2f ", *v++);
		}
		fprintf(f, "\n");
	}
	fprintf(f, "-------------------------------------\n");
	fclose(f);
}
//-----------------------------------------------------------------------------
double LK0_searchI(matr3 &a, matr3 &b, pvector &list, int h, int Nh, int &vx, int &vy, char *prot)	//     h,  Nh , 
{
	//setSqrt(false);					//   S    
	setSqrt(true);						//   S      
	int Nh2 = 2 * Nh + 1;				// 
	double *S0 = new double[Nh2*Nh2];	//    S   
	int iyMin, ixMin;
	double sMin = dbl_MAX;
	for (int iy = 0; iy < Nh2; iy++) {
		int vy = h*(iy - Nh);
		for (int ix = 0; ix < Nh2; ix++) {
			int vx = h*(ix - Nh);
			double t = fSi(a, b, vx, vy, list);
			S0[ix + Nh2*iy] = t;
			if (t < sMin) {
				sMin = t;
				ixMin = ix;
				iyMin = iy;
			}
		}
	}
	if (prot)
		saveArr(S0, Nh2, Nh2, prot, toString("max=%d, step=%d, min(%d,%d)=%8.1f", h*Nh, h, ixMin, iyMin, sMin));
	//   
	//   sMin   (ixMin,iyMin)
	int x0 = ixMin - 1, y0 = iyMin - 1;
	if (x0 < 0) x0++;
	if (x0 >= Nh2 - 1) x0 = Nh2 - 2;
	if (y0 < 0) y0++;
	if (y0 >= Nh2 - 1) y0 = Nh2 - 2;
	//  (x0,y0) -     3*3
	// 0 <= x0,y0 < Nh2

	double f9[9];		//     3*3   h
	f9[0] = S0[x0 + Nh2*y0]; f9[1] = S0[x0 + 1 + Nh2*y0]; f9[2] = S0[x0 + 2 + Nh2*y0];
	f9[3] = S0[x0 + Nh2*y0 + Nh2]; f9[4] = S0[x0 + 1 + Nh2*y0 + Nh2]; f9[5] = S0[x0 + 2 + Nh2*y0 + Nh2];
	f9[6] = S0[x0 + Nh2*y0 + 2 * Nh2]; f9[7] = S0[x0 + 1 + Nh2*y0 + 2 * Nh2]; f9[8] = S0[x0 + 2 + Nh2*y0 + 2 * Nh2];
	delete[]S0;			// S0   
	double ex, ey;
	minBiSq(f9, ex, ey, 1);
	if (prot)
		saveArr(f9, 3, 3, prot, toString("first, step=%d, E=(%7.4f, %7.4f)", h, ex, ey));
	//    :
	ex = h*(x0 + 1 - Nh + ex);
	ey = h*(y0 + 1 - Nh + ey);
	// :
	int x1 = round(ex);
	int y1 = round(ey);

	double R0 = fSi(a, b, x1, y1, list);		//  S   
	if (R0 > f9[4]) {							//    ,   
		x1 = h*(x0 + 1 - Nh);
		y1 = h*(y0 + 1 - Nh);
		R0 = f9[4];
	}
	x0 = x1; y0 = y1;

	//      :
	// (x0,y0) -     R0,
	// (x1,y1) -    R1,
	double R0old=1e99, R1;
	while (R0old > R0) {
		R0old = R0;
		for (int k = 0; k < 8; k++) {
			neighbor8(x0, y0, k, x1, y1);
			R1 = fSi(a, b, x1, y1, list);
			if (R1 >= R0) continue;
			//     k  .    
			do {
				if (prot)
					hWrite(prot, "neib, (%4d,%4d:%7.4f) -> (%4d,%4d:%7.4f)\n", x0, y0, R0, x1, y1, R1);
				x0 = x1; y0 = y1; R0 = R1;
				neighbor8(x0, y0, k, x1, y1);
				R1 = fSi(a, b, x1, y1, list);
			} while (R1<R0);
			//       !
		} //   
	}
	vx = x0; 
	vy = y0;
	return R0;
}


// - -
//  prot,      LK0Searc2.log
void LK0_search(matr3 &a, matr3 &b, pvector &list, int h, int Nh, double &vx, double &vy, char *prot)	//     h,  Nh 
{
	//setSqrt(false);					//   S    
	setSqrt(true);						//   S      
	int Nh2 = 2 * Nh + 1;				// 
	double *S0 = new double[Nh2*Nh2];	//    S   
	int iyMin, ixMin;
	double sMin = dbl_MAX;
	for (int iy = 0; iy < Nh2; iy++) {
		int vy = h*(iy - Nh);
		for (int ix = 0; ix < Nh2; ix++) {
			int vx = h*(ix - Nh);
			double t = fSi(a, b, vx, vy, list);
			S0[ix + Nh2*iy] = t;
			if (t < sMin) {
				sMin = t;
				ixMin = ix;
				iyMin = iy;
			}
		}
	}
	if( prot)
	saveArr(S0, Nh2, Nh2, prot, toString("max=%d, step=%d, min(%d,%d)=%8.1f", h*Nh, h, ixMin, iyMin, sMin));
	//   
	//   sMin   (ixMin,iyMin)
	int x0 = ixMin - 1, y0 = iyMin - 1;
	if (x0 < 0) x0 ++;
	if (x0 >= Nh2) x0 --;
	if (y0 < 0) y0 ++;
	if (y0 >= Nh2) y0 --;
	//  (x0,y0) -     3*3
	// 0 <= x0,y0 < Nh2

	double f9[9];		//     3*3   h
	f9[0] = S0[x0 + Nh2*y0]; f9[1] = S0[x0 + 1 + Nh2*y0]; f9[2] = S0[x0 + 2 + Nh2*y0];
	f9[3] = S0[x0 + Nh2*y0+Nh2]; f9[4] = S0[x0 + 1 + Nh2*y0 + Nh2]; f9[5] = S0[x0 + 2 + Nh2*y0 + Nh2];
	f9[6] = S0[x0 + Nh2*y0 + 2*Nh2]; f9[7] = S0[x0 + 1 + Nh2*y0 + 2 * Nh2]; f9[8] = S0[x0 + 2 + Nh2*y0 + 2 * Nh2];
	delete[]S0;			// S0   
	double ex, ey;
	minBiSq(f9, ex, ey, 1);
	if (prot)
		saveArr(f9, 3, 3, prot, toString("first, step=%d, E=(%7.4f, %7.4f)", h, ex, ey));
	//    :
	ex = h*(x0 + 1 - Nh + ex);
	ey = h*(y0 + 1 - Nh + ey);
	// :
	int x1 = round(ex);
	int y1 = round(ey);

	double newS = fSi(a, b, x1, y1, list);		//  S   
	if (newS > f9[4]) {							//    ,   
		x1 = h*(x0 + 1 - Nh);
		y1 = h*(y0 + 1 - Nh);
	}

	x0 = x1; y0 = y1;

	//   3*3:
	f9[0] = fSi(a, b, x0 - 1, y0-1, list); f9[1] = fSi(a, b, x0, y0-1, list); f9[2] = fSi(a, b, x0 + 1, y0-1, list);
	f9[3] = fSi(a, b, x0 - 1, y0, list); f9[4] = fSi(a, b, x0, y0, list); f9[5] = fSi(a, b, x0 + 1, y0, list);
	f9[6] = fSi(a, b, x0 - 1, y0+1, list); f9[7] = fSi(a, b, x0, y0+1, list); f9[8] = fSi(a, b, x0 + 1, y0+1, list);
	minBiSq(f9, ex, ey, 1);
	if (prot)
		saveArr(f9, 3, 3, prot, toString("second, step=1, (%d,%d)-> E=(%7.4f, %7.4f)", x0, y0, ex, ey));
	//  |ex|==1  |ey|==1     3- :
	int cnt = 3;
	double midValue = f9[4];
	while (fabs(ex) == 1 || fabs(ey) == 1) {
		// :
		x0 = round(x0+ex);
		y0 = round(y0+ey);
		//   3*3:
		f9[0] = fSi(a, b, x0 - 1, y0 - 1, list); f9[1] = fSi(a, b, x0, y0 - 1, list); f9[2] = fSi(a, b, x0 + 1, y0 - 1, list);
		f9[3] = fSi(a, b, x0 - 1, y0, list); f9[4] = fSi(a, b, x0, y0, list); f9[5] = fSi(a, b, x0 + 1, y0, list);
		f9[6] = fSi(a, b, x0 - 1, y0 + 1, list); f9[7] = fSi(a, b, x0, y0 + 1, list); f9[8] = fSi(a, b, x0 + 1, y0 + 1, list);
		if (f9[4] >= midValue - 0.01) break;
		midValue = f9[4];
		minBiSq(f9, ex, ey, 1);
		if (prot)
			saveArr(f9, 3, 3, prot, toString("third, step=1, (%d,%d)-> E=(%7.4f, %7.4f)", x0, y0, ex, ey));
		if (--cnt == 0) break;
	};
	//    :
	vx = ex + x0;
	vy = ey + y0;
}

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

